Attribute VB_Name = "okapi32"
'==============================================================================
'
'       filename        okapi32.bas
'       purpose         API for dynamic loading okapi32.dll (Ok series image cards)
'       language        Microsoft Visual Basic 5.0
'       author          H. Peng
'       date            2000.5.18
'-----------------------
'       modify by       H. Peng
'       purpose         Add Three Function
'       language        Microsoft Visual Basic 5.0
'       date            2001.3
'
'-----------------------
'
'       Copyright (C).  All Rights Reserved.
'
'
'==============================================================================


'---------------okapi32.bas---------------------------------
'
' ok api32 header file for user
'
'---------------------------------------------------------

'----contant defines----

'--defines of ok series image board identity
'Mono series
Public Const OK_M10 = 1010
Public Const OK_M10N = 1010
Public Const OK_M10M = 1013
Public Const OK_M10F = 1011
Public Const OK_M10L = 1014
Public Const OK_M10H = 1012
Public Const OK_M20 = 1020
Public Const OK_M2KC = 1021

Public Const OK_M20H = 1022
Public Const OK_M30 = 1030
Public Const OK_M40 = 1040
Public Const OK_M50 = 1050
Public Const OK_M60 = 1060
Public Const OK_M70 = 1070
Public Const OK_M80 = 1080
Public Const OK_M80K = 1081

'--new updated series
Public Const OK_M10A = 1210
Public Const OK_M10B = 1213                       'OK_M10M:1013
Public Const OK_M10C = 1214                       'OK_M10L/N:1014
Public Const OK_M10D = 1215
Public Const OK_M10K = 1218                       'OK_M80K
Public Const OK_M11K = 1217                       '


Public Const OK_M20A = 1222                       'OK_M20H:1022
Public Const OK_M20B = 1223                       '110M
Public Const OK_M20C = 1224                       '160M
Public Const OK_M20D = 1225                       '205M
Public Const OK_M20G = 1227                       'oem

Public Const OK_M40A = 1240                       'OK_M40:1041
Public Const OK_M40B = 1243                       '110M
Public Const OK_M40C = 1244                       '160M
Public Const OK_M40D = 1245                       '205M

Public Const OK_M60A = 1260                       'OK_M60:1060
Public Const OK_M60B = 1263                       '110M
Public Const OK_M60C = 1264                       '160M
Public Const OK_M60D = 1265                       '205M

Public Const OK_M50A = 1250
Public Const OK_M50B = 1253
Public Const OK_M50K = 1258
Public Const OK_M51K = 1257

Public Const OK_M30A = 1230
Public Const OK_M30B = 1233
Public Const OK_M30K = 1238
Public Const OK_M31K = 1237
Public Const OK_M70A = 1270
Public Const OK_M70B = 1273

'64 bits series
Public Const OK_DM20B = 1223                      '140M
Public Const OK_DM20C = 1224                      '160M
Public Const OK_DM20D = 1225                      '205M

'PCI_X seriesC
Public Const OK_XM20_140 = 1323

'Color series
Public Const OK_C20 = 2020
Public Const OK_C20C = 2021
Public Const OK_C30 = 2030
Public Const OK_C32 = 2032
Public Const OK_C33 = 2033
Public Const OK_C30S = 2031
Public Const OK_C40 = 2040
Public Const OK_C50 = 2050
Public Const OK_C70 = 2070
Public Const OK_C80 = 2080
Public Const OK_C80M = 2081
Public Const OK_C82 = 2082

'RGB series
Public Const OK_RGB10 = 3010
Public Const OK_RGB20 = 3020
Public Const OK_RGB30 = 3030

'Monitor Control series
Public Const OK_MC01 = 4001
Public Const OK_MC03 = 4003
Public Const OK_MC10 = 4010
Public Const OK_MC16 = 4016
Public Const OK_MC20 = 4020
Public Const OK_MC30 = 4030

'--new updated series
Public Const OK_C20A = 2220
Public Const OK_C23A = 2221
Public Const OK_C20B = 2223
Public Const OK_C21B = 2225
Public Const OK_C30A = 2230
Public Const OK_C31A = 2231
Public Const OK_C30B = 2233
Public Const OK_C40A = 2240
Public Const OK_C50A = 2250
Public Const OK_C60A = 2260
Public Const OK_C61A = 2261
Public Const OK_C60B = 2263
Public Const OK_C60C = 2264
Public Const OK_C80A = 2280
Public Const OK_C80K = 2288

Public Const OK_RGB10A = 3210
Public Const OK_RGB11A = 3211
Public Const OK_RGB10B = 3213

Public Const OK_RGB20A = 3220
Public Const OK_RGB21A = 3221
Public Const OK_RGB20B = 3223
Public Const OK_RGB20C = 3224

Public Const OK_RGB30A = 3230
Public Const OK_RGB30B = 3233
Public Const OK_RGB30C = 3234

Public Const OK_RGB60A = 3260
Public Const OK_RGB60B = 3263
Public Const OK_RGB60C = 3265


Public Const OK_VGA40A = 3240
Public Const OK_VGA40B = 3243

Public Const OK_MC10A = 4210
Public Const OK_MC12A = 4212
Public Const OK_MC16A = 4216

Public Const OK_MC20A = 4220

Public Const OK_MC20B = 4223
Public Const OK_MC40B = 4243

Public Const OK_MC40B_E = 4343

'---pc104+ series
Public Const OK_PC10 = 5210
Public Const OK_PC16A = 5216
Public Const OK_PC20A = 5221                   'two cards

'PC 51--
Public Const OK_PC20B = 5123                   'dvd compress


'PR 53--
Public Const OK_PR10B = 5313                   '->rgb10b
Public Const OK_PR20B = 5323                   '->rgb20b
Public Const OK_PR30A = 5330                   '->rgb30a
Public Const OK_PR170 = 5317                   '
Public Const OK_PR30B = 5333                   '->rgb30b

Public Const OK_PR30C = 5334                   '->rgb30b/two input  **
Public Const OK_PR40A = 5340                   'out rgb signal **
Public Const OK_PR43A = 5343                   'out 2 comp signal
Public Const OK_PR50A = 5350                   'standard out rgb

Public Const OK_PR60C = 5364                   'rgb60c with cmp


'PM 54--
Public Const OK_PM10A = 5410                   '->m10a
Public Const OK_PM10B = 5413                   '->m10b
Public Const OK_PM20A = 5420                   '->m20a
Public Const OK_PM20B = 5423                   '->m20b

Public Const OK_PM20D = 5426                   '->613 special signal cap

Public Const OK_PM50G = 5457                   '->m50G special

'---usb series
Public Const OK_USB10A = 5110                  'line scan capture



'USB 52--
Public Const OK_USB20A = 5220                   'std color
Public Const OK_USB20B = 5223                   'non-std b/w capture

'--3.0
'USB3.0 52-- (std)
Public Const OK_USB30A = 5231                   'USB3.0 capture and compress
Public Const OK_USB30B = 5233                   'USB3.0 capture, compress and support sdi


'---cPCI series
Public Const OK_CPC16A = 5230                   'color 16 channels
Public Const OK_CPC50B = 5253                   'm50b
Public Const OK_CPC50G = 5257                   'm20g oem
Public Const OK_CPC66C = 5266                   'rgb66c /6u with cmp

Public Const OK_CPC60C = 5365                   'rgb60c /3u with cmp 53S
Public Const OK_CPC61C = 5361                   'rgb61c //3u rgb/dvi. comp with 60c
Public Const OK_CPC62C = 5362                   'rgb62c //3u camlink
Public Const OK_CPC63C = 5363                   'rgb61c //3u lvds

Public Const OK_CPC61E = 5367                   'same as cpc61c (eqaul to PCI-4E)

'CPCI 55--
Public Const OK_CPC12A = 5512                   'color 12 difference channels

Public Const OK_CPC40C = 5540                   'rgb41c lvds(camlink) output /3u
Public Const OK_CPC41C = 5541                   'rgb41c div output /3u
Public Const OK_CPC41D = 5544                   'incl. OK_CPC41C
Public Const OK_CPC40D = 5542                   '(cpc40c revised) lvds output /3u

Public Const OK_CPC43C = 5543                   'rgb41c /3u 4 comp


'---Digital series
Public Const OK_CL20A = 6120                      'CameraLink
Public Const OK_LV21B = 6224                      'LVDS mpeg-II like c21b
Public Const OK_CL40A = 6140                      '
Public Const OK_CL60A = 6160                      '
Public Const OK_CL20B = 6123                      '
Public Const OK_CL40B = 6143                      '
Public Const OK_CL60B = 6163                      '

Public Const OK_CL20C = 6125                      '
Public Const OK_CL40C = 6145                      '


Public Const OK_LV20A = 6220                      'LVDS
Public Const OK_LV40A = 6240                      '

Public Const OK_LV50A = 6250                      'just output

Public Const OK_LV60A = 6260                      '
Public Const OK_LV20B = 6223                      '
Public Const OK_LV40B = 6243                      '
Public Const OK_LV60B = 6263                      '

Public Const OK_LV20C = 6225                      '
Public Const OK_LV40C = 6245                      '
Public Const OK_LV20G = 6227                      '


'---Line scan series
Public Const OK_LS100A = 7100                     'LS basic type for Analog
Public Const OK_LS100B = 7103                     'LS second type for Analog
Public Const OK_LS120A = 7120                     'LS basic type for CameraLink
Public Const OK_LS120B = 7123                     'LS second type for CameraLink
Public Const OK_LS200A = 7200                     'LS second class for Analog



'---FireWare (1394) series
Public Const OK_FW10A = 8410

'---fibre optical series
Public Const OK_FB10A = 8510

'---GigE net series
Public Const OK_GN10A = 8610
Public Const OK_GN20A = 8620
Public Const OK_GN40A = 8640                    '4 channs
Public Const OK_GN40A_E = 8643                  'PCI_E 4 channs
Public Const OK_GN40A_4E = 8644                 'PCI_E 4 channs



'---DSP series
Public Const OK_DSP100A = 9100                    'DSP capture process




'---PCI-Express and PCI_X series
'Mono series

'#define       OK_M40A_E               1340    //
'#define       OK_M40B_E               1343    //

'#define       OK_M20B_4E              1423    //
'#define       OK_M40B_4E              1443    //

Public Const OK_M10B_E = 1313                     '
Public Const OK_M10K_E = 1318                     '
Public Const OK_M20A_E = 1322                     '
Public Const OK_M20B_E = 1323                     '

Public Const OK_M30B_E = 1333                     '
Public Const OK_M50B_E = 1353                     '

'Color series
Public Const OK_C20A_E = 2320
Public Const OK_C21B_E = 2325
Public Const OK_C30A_E = 2330

Public Const OK_C61A_E = 2361
Public Const OK_C60B_E = 2363

'RGB series
Public Const OK_RGB20A_E = 3320
Public Const OK_RGB20B_E = 3323
Public Const OK_RGB30A_E = 3330
Public Const OK_RGB30B_E = 3333

Public Const OK_RGB60A_E = 3360                'cmp
Public Const OK_RGB60B_E = 3363                'cmp
Public Const OK_RGB60C_E = 3365                'cmp
Public Const OK_RGB61C_E = 3366                'DVI/cmp
Public Const OK_RGB60C_X = 3565                'cmp
Public Const OK_RGB61C_X = 3566                'DVI/cmp
Public Const OK_RGB61C_4E = 3466               'DVI/VGA/cmp

Public Const OK_VGA40A_E = 3340
Public Const OK_VGA41A_E = 3341
Public Const OK_VGA40B_E = 3343
Public Const OK_VGA41B_E = 3344

Public Const OK_VGA51A_E = 3351                'DVI/AUDIO

Public Const OK_VGA40B_4E = 3443               'PCI-4E
Public Const OK_VGA41A_4E = 3441               'PCI-4E single DVI/VGA
Public Const OK_VGA41B_4E = 3444               'PCI-4E two DVI/VGA
Public Const OK_VGA41C_4E = 3445               'PCI-4E HR DVI

Public Const OK_VGA40A_X = 3540
Public Const OK_VGA41A_X = 3541                'DVI
Public Const OK_VGA40B_X = 3543
Public Const OK_VGA41B_X = 3544                'DVI

'Monitor Control series
Public Const OK_MC10A_E = 4310                    '
Public Const OK_MC12A_E = 4312                    '

Public Const OK_MC30A_E = 4330
Public Const OK_MC20B_E = 4323
'Public Const OK_MC40B_E = 4343

'4E
Public Const OK_MC40A_4E = 4440                   '
Public Const OK_MC40C_4E = 4445                   ' with comp


'CameraLink
Public Const OK_CL20A_E = 6320                    'CameraLink
Public Const OK_CL40A_E = 6340                    '
Public Const OK_CL60A_E = 6360                    '
Public Const OK_CL20B_E = 6323                    '
Public Const OK_CL40B_E = 6343                    '
Public Const OK_CL60B_E = 6363                    '

'LVDS-RS644
Public Const OK_LV20A_E = 6420                    'LVDS
Public Const OK_LV40A_E = 6440                    '
Public Const OK_LV60A_E = 6460                    '
Public Const OK_LV20B_E = 6423                    '
Public Const OK_LV40B_E = 6443                    '
Public Const OK_LV60B_E = 6463                    '

'SDI
Public Const OK_SDI40A_E = 6540                   'SDI
Public Const OK_SDI40B_E = 6543                   'H_SDI

'---Ok sereis Camera
'LVDS-RS644
Public Const OK_AM1530 = 201530                  'LVDS


'USB2.0 series
Public Const OK_AM1110 = 201110                   'USB
Public Const OK_AM1111 = 201111
Public Const OK_AM1310 = 201310
Public Const OK_AM1410 = 201410
Public Const OK_AM1510 = 201510

Public Const OK_AM9010 = 209010                   'for DR
Public Const OK_GAM1610 = 601610                  'for DR
Public Const SUPERCCD_1680 = 201680               '$
Public Const SUPERCCD_1681 = 201681               '$

Public Const OK_AC1210 = 211210
Public Const OK_AC1310 = 211310

Public Const OK_AC168 = 210168                    'oem
Public Const OK_AC168N = 210169                   'oem

Public Const OK_SM1310 = 301310
Public Const OK_SC1310 = 311310
Public Const OK_SC2010 = 312010
Public Const OK_SC3010 = 313010

Public Const OK_SM130 = 300130                    'oem

Public Const OK_GSM1410 = 701410
Public Const OK_GSC1410 = 711410
Public Const NS_DR16 = 700116                     'oem

'FireWare(1394)
Public Const OK_AM1340 = 201340                   '1394

'Optical
Public Const OK_AC1350 = 211350                   '

'GigE series (Remote net camera)
Public Const OK_AM1160 = 201160                   '
Public Const OK_AM1161 = 201161                   '
Public Const OK_AM1360 = 201360                   '
Public Const OK_AM1460 = 201460                   '
Public Const OK_AM1560 = 201560                   '
Public Const OK_AM1561 = 201561                   ' plus

Public Const OK_AM1565 = 201565                   ' special for x-ray for GE
Public Const OK_AM1566 = 201566                   ' special for x-ray

Public Const OK_AM1666 = 201666                   ' Kodak sereis

'--67 (GIGE 29x29 sereis)

Public Const OK_AM2067 = 202067                  ' ccd b/w 2.0 M Pixels
Public Const OK_AC2067 = 212067                  ' ccd color 2.0 M Pixels
Public Const OK_AM2167 = 202167                  ' ccd b/w 2.0 M Pixels (double channels)
Public Const OK_AC2167 = 212167                  ' ccd color 2.0 M Pixels (double channels)

Public Const OK_AM5067 = 205067                  ' ccd b/w 5.0 M Pixels
Public Const OK_AC5067 = 215067                  ' ccd color 5.0 M Pixels

Public Const OK_GAM2967 = 602967                 ' ccd b/w 29 M Pixels

Public Const OK_SM1367 = 301367                  ' cmos b/w 1.3 M Pixels
Public Const OK_SC1367 = 311367                  ' cmos color 1.3 M Pixels

Public Const OK_SM5067 = 305067                  ' cmos b/w 5.0 M Pixels
Public Const OK_SC5067 = 315067                  ' cmos color 5.0 M Pixels



'--68 (kodak ccd) (GIGE 2-channel sereis )

'--1023x1024
Public Const OK_AM1168 = 201168                  ' (5.5, b/w, 1 MPix, single net interface) #
Public Const OK_AC1168 = 211168                  ' (5.5, color, 1 MPix, single) #
Public Const OK_AM1268 = 201268                  ' (5.5, b/w, 1 MPix, double)  #
Public Const OK_AC1268 = 211268                  ' (5.5, color, 1 MPix, double) #

'--(1600x1200)
Public Const OK_AM2168 = 202168                  ' (5.5, b/w, 2 MPix, single)
Public Const OK_AC2168 = 212168                  ' (5.5, color, 2 MPix, single)
Public Const OK_AM2268 = 202268                  ' (5.5, b/w, 2 MPix, double)
Public Const OK_AC2268 = 212268                  ' (5.5, color, 2 MPix, double)

'--(1920x1080)
Public Const OK_AM2368 = 202368                  ' (5.5, b/w, 2 MPix, single) #
Public Const OK_AC2368 = 212368                  ' (5.5, color, 2 MPix, single)
Public Const OK_AM2468 = 202468                  ' (5.5, b/w, 2 MPix, double)  #
Public Const OK_AC2468 = 212468                  ' (5.5, color, 2 MPix, double) #

'--(1920x1080)
Public Const OK_AM2568 = 202568                  ' (7.4, b/w, 2 MPix, single)
Public Const OK_AC2568 = 212568                  ' (7.4, color, 2 MPix, single)
Public Const OK_AM2668 = 202668                  ' (7.4, b/w, 2 MPix, double) #
Public Const OK_AC2668 = 212668                  ' (7.4, color, 2 MPix, double) #

'--(2336x1752)
Public Const OK_AM4168 = 204168                  ' (5.5, b/w, 4 MPix, single)
Public Const OK_AC4168 = 214168                  ' (5.5, color, 4 MPix, single)
Public Const OK_AM4268 = 204268                  ' (5.5, b/w, 4 MPix, double) #
Public Const OK_AC4268 = 214268                  ' (5.5, color, 4 MPix, double) #

'--(2048x2048)
Public Const OK_AM4568 = 204568                  ' (7.4, b/w, 4 MPix, single)
Public Const OK_AC4568 = 214568                  ' (7.4, color, 4 MPix, single)
Public Const OK_AM4668 = 204668                  ' (7.4, b/w, 4 MPix, double) #
Public Const OK_AC4668 = 214668                  ' (7.4, color, 4 MPix, double) #

'--(3296x2472)
Public Const OK_AM8168 = 208168                  ' (5.5, b/w, 8 MPix, single)
Public Const OK_AC8168 = 218168                  ' (5.5, color, 8 MPix, single)
Public Const OK_AM8268 = 208268                  ' (5.5, b/w, 8 MPix, double) #
Public Const OK_AC8268 = 218268                  ' (5.5, color, 8 MPix, double) #


'--(4896x3264)
Public Const OK_GAM1568 = 601568                 ' (5.5, b/w, 16 MPix, single)
Public Const OK_GAC1568 = 611568                 ' (5.5, color, 16 MPix, single)
Public Const OK_GAM1668 = 601668                 ' (5.5, b/w, 16 MPix, double) #
Public Const OK_GAC1668 = 611668                 ' (5.5, color, 16 MPix, double)

'--(4864x3232)
Public Const OK_GAM1768 = 601768                 ' (7.4, b/w, 16 MPix, single)
Public Const OK_GAC1768 = 611768                 ' (7.4, color, 16 MPix, single)
Public Const OK_GAM1868 = 601868                 ' (7.4, b/w, 16 MPix, double) #
Public Const OK_GAC1868 = 611868                 ' (7.4, color, 16 MPix, double)


'--(6576x4384)
Public Const OK_GAM2568 = 602568                 ' (5.5, b/w, 29 MPix, single)
Public Const OK_GAC2568 = 612568                 ' (5.5, color, 29 MPix, single)
Public Const OK_GAM2668 = 602668                 ' (5.5, b/w, 29 MPix, double) #
Public Const OK_GAC2668 = 612668                 ' (5.5, color, 29 MPix, double)


'--

Public Const OK_AM1751 = 201751                   ' e2v sereis, customized

Public Const OK_AC1260 = 211260                   '
Public Const OK_AC1360 = 211360                   '
Public Const OK_AC1361 = 211361                   '

'--Linear scan with GigE interface
Public Const OK_LM1060 = 101060                     '1K
Public Const OK_LM2060 = 102060                     '2K
Public Const OK_LC2060 = 112060                     '2K color
Public Const OK_LC4060 = 114060                     '4K color


'------------------------------------
'Intellegent Camera
Public Const OK_IC1200 = 181200                   '
Public Const OK_IC1500 = 181500                   '


Public Const OK_IM1161 = 171161                  ' b/w 640x480, Gnet
Public Const OK_IM1160 = 171160                  ' b/w 7680x576, Gnet


'------Embeded parts-------------------------------------
'GigE converter
Public Const OK_GE130 = 10130                     '
Public Const OK_GE400 = 10400                     '

Public Const OK_DX160 = 21160                   ' GigE CCU (type I)
Public Const OK_DX260 = 21260                   ' GigE CCU (type II)

'--error code

Public Const ERR_NOERROR = 0                  'no error
Public Const ERR_NOTFOUNDBOARD = 1            'not found available ok board

Public Const ERR_NOTFOUNDVXDDRV = 2           'not found ok vxd driver
Public Const ERR_NOTALLOCATEDBUF = 3          'not pre-allocated buffer from host memory
Public Const ERR_BUFFERNOTENOUGH = 4          'available buffer not enough requirment
Public Const ERR_BEYONDFRAMEBUF = 5           'capture iamge size beyond buffer

Public Const ERR_NOTFOUNDDRIVER = 6           'no driver found
Public Const ERR_NOTCORRECTDRIVER = 7         'driver not correct

Public Const ERR_MEMORYNOTENOUGH = 8          'memory not enough
Public Const ERR_FUNNOTSUPPORT = 9            'the function not support
Public Const ERR_OPERATEFAILED = 10           'something wrong with the operation

Public Const ERR_HANDLEAPIERROR = 11          'the handle to okapi function wrong
Public Const ERR_DRVINITWRONG = 12            'something wrong with driver initialize

Public Const ERR_RECTVALUEWRONG = 13          'the rect set wrong
Public Const ERR_FORMNOTSUPPORT = 14          'the form set not support by the board

Public Const ERR_TARGETNOTSUPPORT = 15        'the target not support by this function

Public Const ERR_NOSPECIFIEDBOARD = 16        'not found specified board correctly sloted

'--format defines
Public Const FORM_RGB888 = 1                  'rgb format
Public Const FORM_RGB565 = 2
Public Const FORM_RGB555 = 3
Public Const FORM_RGB8888 = 4
Public Const FORM_RGB332 = 5
Public Const FORM_RGB8886 = 18

Public Const FORM_YUV422 = 6                  'yuu format
Public Const FORM_YUV411 = 7
Public Const FORM_YUV16 = 8
Public Const FORM_YUV12 = 9
Public Const FORM_YUV9 = 10
Public Const FORM_YUV8 = 11

Public Const FORM_GRAY888 = 12                'gray format
Public Const FORM_GRAY8888 = 13
Public Const FORM_GRAY8 = 14
Public Const FORM_GRAY10 = 15
Public Const FORM_GRAY12 = 16
Public Const FORM_GRAY14 = 17
Public Const FORM_GRAY16 = 19
Public Const FORM_GRAY4 = 20                   'added 090822
Public Const FORM_GRAY12PACKED = 21            'added 110602
Public Const FORM_GRAY10PACKED = 22            'added 110602

Public Const FORM_BAYGR8 = 23                 'bayer format
Public Const FORM_BAYRG8 = 24                 'added on 20140926
Public Const FORM_BAYGB8 = 25
Public Const FORM_BAYBG8 = 26

Public Const FORM_BAYGR16 = 27
Public Const FORM_BAYRG16 = 28
Public Const FORM_BAYGB16 = 29
Public Const FORM_BAYBG16 = 30



'--mask command
Public Const MASK_DISABALE = 0                'turn of mask
Public Const MASK_POSITIVE = 1                '0 win clients visible, 1 video visible
Public Const MASK_NEGATIVE = 2                '0 for video 1 for win client (graph)


'--tv system standard
Public Const TV_PALSTANDARD = 0               'PAL
Public Const TV_NTSCSTANDARD = 1              'NTSC
Public Const TV_NONSTANDARD = 2               'NON_STD
Public Const TV_HDTVSTANDARD = 3              'HDTV_STD
'Public Const TV_SECAMSTANDARD = 3             'SECAM

'--HDTV sub mode
Public Const HDTV_480P = 1                    '480 Lines Progressive scan
Public Const HDTV_720P = 2                    '720 Lines Progressive scan
Public Const HDTV_1080I = 3                   '1080 Lines Interlaced scan
Public Const HDTV_1080P = 4                   '1080 Lines Interlaced scan


Public Const TV_PALMAXWIDTH = 768
Public Const TV_PALMAXHEIGHT = 576

Public Const TV_NTSCMAXWIDTH = 640            '720
Public Const TV_NTSCMAXHEIGHT = 480


'-----defines lParam for get param
Public Const GETCURRPARAM = -1

'-----sub-function defines for wParam of SetVideoParam
        'wParam cab be one of the follow
Public Const VIDEO_RESETALL = 0                 'reset all to sys default
Public Const VIDEO_SOURCECHAN = 1               'lParam=0,1.. Comp.Video; 0x100,101...to Y/C(S-Video), 0x200,0x201 to RGB/VGA Chan.Input,
                                                '0x400,0x401 to YPrPb, 0x800,0x801 to DVI/HDMI, 0x900,0x901 to HDMI(YPbPr)
                                                'return max support Comp. Video channles when input lParam=0xff.
                                                'as same way return max s-video channeles when input lParam=0x1ff.
                                                'and return max rgb/vga video channeles when input lParam=0x2ff.
                                                'and return max YPrPb video channeles when input lParam=0x4ff.
                                                'and return max DVI/HDMI(RGB) channeles when input lParam=0x8ff.
                                                'and return max HDMI(YPbPr) channeles when input lParam=0x9ff.
                                                'and return max SDI channeles when input lParam=0xAff.


Public Const VIDEO_BRIGHTNESS = 2               'LOWORD is brightness, for RGB HIWORD is channel (0:red, 1:green, 2:blue)
Public Const VIDEO_CONTRAST = 3                 'LOWORD is contrast, for RGB HIWORD is channel (0:red, 1:green, 2:blue)
                            
Public Const VIDEO_COLORHUE = 4                 'LOWORD is hue of color,  for YUV/YPbPr HIWORD=0 is for V/Pr, =1 for U/Pb
Public Const VIDEO_SATURATION = 5               'LOWORD is saturation of color,  for YUV/YPbPr HIWORD=0 is for V/Pr, =1 for U/Pb
Public Const VIDEO_GAINADJUST = 18              ' gain adjust, some card support range 0~255, some just 0~3
Public Const VIDEO_PHASEADJUST = 20             'phase adjust

Public Const VIDEO_RGBFORMAT = 6                'when return, low word is format code
Public Const VIDEO_TVSTANDARD = 7               'Main Mode:LOWORD 0 PAL, 1 NTSC, 2 Non-stadard, HDTVSTANDARD,
                                                'Sub Mode: HIWORD 1 HDTV_480P, ...
Public Const VIDEO_SIGNALTYPE = 8               'LOWORD 0: non-interlaced(progressive), 1: interlaced
                                                '2:single pixel, 3:double pixels (for digital signal), 4:double pixels (inverse pixel order)
                                                '5:treble pixels, 6:quad pixels
                                                'HIWORD: trigger mode(/slot in field header for standard tv video).
                                                '0= continu. signal, =1: edge-trigger(hardware or software)
                                                'for camera, =2: pulse width trigger, =3: extern sync mode, =4: keep one after trigger,
                                                '=5: keep last one after trigger,
                                                'when lParam==-2, just get capability of LOWORD, if return -1: not support;
                                                'when lParam==-3, just get capability of HIWORD, if return -1: not support
Public Const VIDEO_SYNCSIGCHAN = 10             'LOWORD: sync line of source channel, =0:Red,1:Grn,2:Blue, 3:Sync,4 H.V.Sync;
                                                'usually =1, 3 or 4 when vidoe input is rgb source
                                                'HIWORD: which source the sync line is in. =0,1,..for RGB source 0,1,
                                                '=0x100,0x101,... for comp.video source 0,1, (in this case(comp. video) LOWORD has no mean more)
Public Const VIDEO_IMAGESOURCE = 36             'LOBYTE(BYTE0): 0(defalut): alive(continuous), 1: last image, 2:black, 3: white, 4: vertical-lines
                                                '5: vertical-lines changing
                                                'BYTE1: select chann(based 0) to store or process
                                                'b16=1: test light on, b17:histogram in pic

Public Const VIDEO_AUXMONCHANN = 11             'BYTE0(LOBYTE): monitor video source chann on aux monitor for MC30
                                                'BYTE1(B8:15) special for LV20G
                                                'HIWORD select out video channel(when more than 1, e.g for CCU)

Public Const VIDEO_RECTSHIFT = 9                'video rect shift,  makelong (x,y)
Public Const VIDEO_RECTSHIFTEX = 19             'general video active rect shift for all,  makelong (x,y)
                                                'replace for VIDEO_RECTSHIFT

Public Const VIDEO_AVAILRECTSIZE = 12           'makelong(horz,vert). horz available pixels per scan line and
                                                'vert available lines per frame
Public Const VIDEO_FREQSEG = 13                 ' set video pixel frequency range
                                                'LOWORD, 0:Low(7.5~15MHz),  1:middle(15~30), 2:High(30~60), 3:ultra(60~120), 4:very(>120)
                                                'HIWORD =1: mean LOWORD is specified frequency value (like 120 mean 120MHz)

Public Const VIDEO_MISCCONTROL = 16             ' miscellaneous control bits
                                                'b0:-satur, b1:- contr (for c20, c30)
                                                'b2:agc, b3:gama, b4:b/w,
                                                'b5:fast mode (for c30b)
                                                'b6: 1: std high bit mode (like 12...), 0: compatible 10b mode for LVDS digital input
                                                'b7: 1: switch off auto zoom mode when output is different from source
                                                'b8: 1:VTR mode, 0:auto mode
                                                'b9: 1: close language select, 0:open
                                                'b10: 1: inverse gray of out video
                                                'b11: 1: enable electronic circle
                                                'b12: 1: enable rect to measure visible


Public Const VIDEO_ENABLEGRAPHS = 17            ' enable graph. LOBYTE,b0: enable cap-graph; b1: enb out-graph.  HIBYTE graph frm sel

'--set local device
Public Const VIDEO_SETBADPTNUM = 25             ' set number of bad point, LOWORD= number(based 1).  and  HIWORD=1 mean enable removing bad points, 0: stay there       //
Public Const VIDEO_SETBADPTPOS = 26             ' set position of bad point, LOWORD=x, HIWORD=y

Public Const VIDEO_TAGFRMCOUNT = 27             ' LOWORD=1: turn on frame counter and tag it to each frame, =0 off;
                                                ' HIWORD=1 reset frame counter
'--
Public Const VIDEO_SETWATCHDOG = 28             ' set watchdog, LOWORD= 0: off wotchdog, >0: enable, and it is timer in seconds(1~255)
Public Const VIDEO_SETDATETIME = 29             ' set and get date and time embeded in hardware. lParam should be pointer to struct tm (include date and time)
                                                'if lParam=0, it will take current system date and time; You can get current datetime of device by setting tm.tm_year=-1
Public Const VIDEO_RESETSYSTEM = 30             ' bits0=1 restart system timer, b1=1: clear system's flash memory

Public Const VIDEO_SETDELAYLINES = 39           '(for LineScan camera) LOWORD is delay lines between two channels(R,G, or B), HIWORD =0 mena R is first channel, =1: B is first one

'--set params of video out to the other device

Public Const VIDEO_OUTLINEPERIOD = 14           'LOWORD out line period (in 0.54 us) generated by board, when HIWORD==0:in 0.54 us, =1: in 0.1 vs, =2: in 0.01vs ...
Public Const VIDEO_LINEPERIOD = 14              'LOWORD out line period (in 0.54 us) generated by board, when HIWORD==1:in 0.1 vs, ...
                                        

Public Const VIDEO_OUTFRAMELINES = 15           'out lines per frame generated by board, HIWORD is local sync
Public Const VIDEO_FRAMELINES = 15              'when outlines<2/3* caspture vert lines, it will zoom vert to half lines
                                                'for digtal cards
Public Const VIDEO_OUTSIGNALTYPE = 22           'out signal type, b0:in grn, b1:comp sync, b2:interlace
                                                'b3:neg pole of horz sync;
                                                'b4~5:vert half or double. 0:auto set (when VIDEO_FRAMELINES set is 1/3 difference from CAPTURE_VERTLINES,
                                                '0: auto-set, 1=forced half, 2=forced double, 3: forced set no
                                                'b6:neg pole of vert sync
                                                'HIWORD: b16~19: b16=1: off out video channel 0, b17=1: off out video channel 1. etc.
                                                '(only two channs for cpc50b, 4 channs for PR43A)

Public Const VIDEO_OUTHORZPIX = 23              ' set out horz total pixel on the monitor

Public Const VIDEO_OUTXYOFFSET = 24             ' set offset of pixels in horz and vert directions on monitor

Public Const VIDEO_OUTHVSYNCWID = 41            ' set out horz and vert sync width (in unit pixle and line). LOWORD is for horz sync and HIWORD is for vert sync.

Public Const VIDEO_OUTWINDOWLEVEL = 40          ' set gray level window's location (start pos) and its width for high bits (>8)
                                                ' LOWORD = middle gray level, HIWORD = width, turn of when HIWORD=0;


Public Const VIDEO_OUTMODESET = 38              '(for cpc41c)set mode of out video. LOWORD(mode)=0: no action, =1: pause, =2: resume, =3: forward when HIWORD>0, backward when HIWORD<0
                                                '=4: go to specified frame number(=HIWORD), =5: step to number(=HIWORD, may be negative) of frames relative to current frame

Public Const VIDEO_PARTIALMODE = 31             'partial mode, 0(default): normal(global) mode, non 0: partial mode
                                                'when partial mode LOWORD= start line number, HIWORD= end line number


'--set some rect to process
Public Const VIDEO_ELLIPSEOFFSET = 32           ' ellipse(electronic circle) offset (left,top), makelong(horz left offset,vert top offset)
Public Const VIDEO_ELLIPSESIZE = 33             ' ellipse(electronic circle) size (width, height), makelong(horz width, vert hight)

Public Const VIDEO_MEASUREOFFSET = 34           'for IBS, measure rect's offset (left,top), makelong(horz left offset,vert top offset) for IBS...
Public Const VIDEO_MEASURESIZE = 35             'for IBS, measure rect's size (width, height), makelong(horz width, vert hight)


Public Const VIDEO_CURRHISTOGRAM = 37           'just get current histogram of specified measure rect (default for whole image). return length (256 for gray 8).
                                                'lParam=1: enable evaluate histogram; =0; disable; =-1; just return length,; else is pointer to address to store histogram in INT32, =1;
'max=37
    
'-----sub-function defines for wParam of SetCaptureParam
        'wParam cab be one of the follow
Public Const CAPTURE_RESETALL = 0               ' reset all to sys default
Public Const CAPTURE_INTERVAL = 1               ' LOWORD is number of frm interval, mean take one frm every LOWORD+1 frames;
                                                ' HIWORD is about number per 10 seconds (frm rate). LOWORD is valid only HIWORD is 0
Public Const CAPTURE_CLIPMODE = 2               ' LOWORD: clip mode when video and dest rect not same size
                                                ' exHiWord: if captrure odd and even field crosslly
Public Const CAPTURE_SCRRGBFORMAT = 3           ' when return, loword=code, exHiWord=bits
Public Const CAPTURE_BUFRGBFORMAT = 4
Public Const CAPTURE_FRMRGBFORMAT = 5
Public Const CAPTURE_BUFBLOCKSIZE = 6           ' lParam=MAKELONG(width,height)
                                                ' if set it 0 (default), the rect set by user will be as block size
Public Const CAPTURE_HARDMIRROR = 7             'LOWORD mirror: bit0 x, bit1 y; default for both capture and playback
                                                'when lParam==-2, if return -1: not support output mirror indepent from capture;
                                                'Note when lParam's b7=1: mean set capture and playback seperately.
                                                'b4:x, b5:y for output mirror (if support indepent),
                                                '
                                                'HIWORD special rotate: b16:17: special angle rotate, b16~17=1: rotate 90 degree left, =2: 90 right, =3 180 degree
                                                'when lParam==-3, check if support rotate special angle, return -1, not support
Public Const CAPTURE_ANGLEROTATE = 34           'arbitrary angle rotate.  LOWORD b0~11: angle to ratate in degree (1 represent 1/10 degree)
                                                'when lParam= -2, if return -1: mean not support output rotate indepent from capture.
                                                'HIWORD, b31=1 mean set capture and playback seperately.
                                                'if so, b16~27: angle to ratate in degree (1 represent 1/10 degree)
                                                'This set wiil be ignored when HIWORD in CAPTURE_HARDMIRROR is not 0

Public Const CAPTURE_VIASHARPEN = 8             ' sample via sharpen filter
Public Const CAPTURE_VIAKFILTER = 9             ' sample via recursion filter
                                                'when lParam==-2, just get capability of LOWORD, if return -1: not support;
                                                'when lParam==-3, just get capability of HIWORD, if return -1: not support

Public Const CAPTURE_SAMPLEFIELD = 10           ' 0 in field (non-interlaced), 1 in frame (interlaced), (0,1 are basic)
                                                ' 2 in field but keep expend row,3 in field but interlaced one frame
                                                ' (2,4 can affect only sampllng field(frame) by field(frame) )
                                                ' in 3 up-dn frame
Public Const CAPTURE_HORZPIXELS = 11            ' set max horz pixel per scan line
Public Const CAPTURE_VERTLINES = 12             ' set max vert lines per frame

Public Const CAPTURE_SCROFFSETVID = 21          ' set screen offset in video's rect just for screen scroll
                                                ' affecting Capture to SCREEN and ConvertRect to or from SCREEN

Public Const CAPTURE_ARITHMODE = 13             'arithmatic (and model image) mode  LOWORD =0:no, =1:V-M, =2:V+M, =3:V+M
Public Const CAPTURE_TO8BITMODE = 14            ' the mode of high (eg. 10 bits) converted to 8bit
                                                ' exHiWord(lParam)=0: linear scale,
                                                ' exHiWord(lParam)!=0:clip mode, LOWORD(lParam)=offset

Public Const CAPTURE_SELRGBDATA = 37            'LOWORD: select some rgb channel's data to capture as gray image (cpc61c)
                                                '0: default for all, 1:red, 2:green, 3:blue


Public Const CAPTURE_SEQCAPWAIT = 15            ' bit0 if waiting finished for functions of sequence capturing and playbacking
                                                ' bit1 if waiting finished capture then call callback function

Public Const CAPTURE_TRIGCAPTURE = 17           'set triggered capture, LOWORD cap no of fields, HIWORD delay fields after trigger

Public Const CAPTURE_TURNCHANNELS = 18          'turn channels when sequence capture
                                                'b0~6 for turn number (max 127),
                                                'b8~23(16) mask 0~15 channles, b7=1 keep this pos
                                                'b28~31, interval in turn, mean turn one time every interval

Public Const CAPTURE_MISCCONTROL = 16           ' miscellaneous control bits
                                                ' b0: 1: forced okCaptureByBuffer or okGetSeqCapture controled by interrupt
                                                ' b1: 1: take one by one to okCaptureSequence, and okCaptureByBuffer or okGetSeqCapture controled by interrupt
                                                ' bit2: 1: one by one for usb20
                                                ' b3: 1: capture all 12 bits, 0: capture 10 bits signal for 12 cards like LV20B...
                                                ' b4: 1: horz count from sync's up-edge; 0: down-edge for some cards like LVDS etc.
                                                ' b5: 1: vert count from sync's up-edge; 0: down-edge for some cards like LVDS etc.
                                                ' b6: 1: partial mode for camera, 0: global mode (default)
                                                ' b7: 1: forced to okCaptureTo and okCaptureActive changed to okCapturebyBuffer
                                                '    note: this bit can be set only when its respond bit in hiword is 1.
                                                ' b8: 0,1 x align adjust for Bayer format
                                                ' b9: 0,1 y align adjust for Bayer format
                                                ' b10: 1 enable pass lut/gamma
                                                ' b11:1 take 8 frms as buffer for okCaptureByBuffer, default take 2 frms

'--
Public Const CAPTURE_SETLATENCY = 24            ' set PCI latency, default =0xf8, it is better to set to 0x18 when multi-cards
Public Const CAPTURE_SLEEPTIMES = 25            ' relex times and set max times to wait for all sequence capure functions.
                                                ' LOWORD: a level to release cpu times. 0: disable, 1:system auto (default), >=2 specified level
                                                ' HIWORD: max wait times (in unit 10 milli-second) to wait to next frame. 0:system auto (default).

'--set some camera params
Public Const CAPTURE_EXPOSETIME = 20            '(like camera) set exposed time, in unit us (microsecond), -2: get max valid exponsetime
Public Const CAPTURE_DELAYEXPOSE = 27           '(for camera) set delay time to expose for camera, in unit us (microsecond) from the Basetime (ususally begin after a ex-trigger)

Public Const CAPTURE_FRAMERATE = 22             'for area camera, LOWORD is transfer frame rate (be equa less current hardware frm rate set); HIWORD is hardware frm rate of camera,
                                                'and default: HIWORD=0 mean set to max frm rate to support. when lParam=-2, return how many classes of (hardware) frm rate to support,
                                                'lParam=-3, return max (hardware) frame rate to support
                                                'for line scan camera, LOWORD is line rate (Lines/S) and HIBYTE be set to 0x80;

Public Const CAPTURE_SETTEMPER = 23             ' for camera, set camera temperature expected, and to get current real temperature of camera when set -2

Public Const CAPTURE_WHITEBALANCE = 26          'for camera, set white balance for camera, LOWORD=0: off, =1:onetime, =2:always
                                                'HIWORD=0: default(auto), =1: daylight, =2:fluorescence, =3 incandesent lamp,...
Public Const CAPTURE_SETBINNINGMODE = 28        'for camera, LOWORD set binning mode, 0:normal mode ,when BYTE1=0, BYTE0=0,1: 1x1, =2: 2x2, =3: 3x3, ...
                                                'when BYTE1!=0, mean BYTE0 is binning number on x-direction, BYTE1 is in y-direction
                                                'HIWORD is soft binning (sample ratio), default=0 mean take whole iamge, when BYTE3=0, BYTE0=0,1: whole, =2: 1/2x1/2
                                                'when BYTE3!=0, mean BYTE2 is sample ratio in x-direction and BYTE3 is in y-direction
 
Public Const CAPTURE_ENBCAMFUNC = 29            'for camera, enable camera's functions, b0: auto-adjust mode, and then BYTE2(when non 0) is specified target gray(8Bits);
                                                'b1: gray stretch; b2: histogram equaliize;
                                                'b3: enable removing isolated spot, and then if BYTE3 (when non 0 ) is specified gray threshold (8Bits)

Public Const CAPTURE_GAMMAFACTOR = 30           'for camera, set gamma factorX100 (it is between 0~2 for some camera)

Public Const CAPTURE_FLATFIELDING = 36          'for camera, frame grabber,  flat fielding (shadow correct),
                                                'LOWORD=1: capture a dark field in BUFFER 0, =2; a bright one in BUFFER 1, =3: generat correct model
                                                'HIWORD=1 enable flat field correct with self-created model, =0x100: disable
'--
Public Const CAPTURE_SETCOMPPARAM = 31          ' LOWORD: qualitiy factor(1~100 for jpg,mjpg), HIWORD: specify compress format(1=JPG, 2=PNG, 3=TIFF, ...)

Public Const CAPTURE_PACKETINTERVAL = 32        'set interval(in 10 vs) between two packets to send in order to control transfer rate (for capture device based net)
                                                '0: auto-mode, default=0, genarally max is about 6000000(60Seconds). when lParam= -2 return true max value
Public Const CAPTURE_PACKETSIZE = 33            'set packet size in byte (for capture device based net), min=8, default=1500, max is 2048
Public Const CAPTURE_WAITASKRESEND = 35         'wait how many packets to ask re-send when some packet was missing (for capture device based net)
'max=36

'#define       CAPTURE_OUTHORZPOS      20  // set out horz offset and width on the monitor
'#define       CAPTURE_OUTVERTPOS      21  // set out vert offset and height on the monitor
'#define       CAPTURE_OUTHORZPIX      22  // set out horz total pixel



'----defines sub-param lParam for CAPTURE_SAMPLEFIELD
Public Const SAMPLE_INFIELD = 0             'in field (non-interlaced)
Public Const SAMPLE_INFRAME = 1             'in frame of interlaced fields
                                            'the above two (0,1) are basic
Public Const SAMPLE_FIELDEXP = 2            'in field but expend (keep expend row)
Public Const SAMPLE_UPDNFRAME = 3           'in frame of up-downed fields
Public Const SAMPLE_FIELDINTER = 4          'in field but interlaced to one frame, from even
Public Const SAMPLE_INTOPFIELD = 5          'in field just top field

'-----defines sub-param lParam for CAPTURE_CLIPMODE
Public Const RECT_SCALERECT = 0
Public Const RECT_CLIPCENTER = 1
Public Const RECT_FIXLEFTTOP = 2
                    'in condition video rect great than screen rect:
                    'if RECT_SCALERECT video rect will be scaled to match screen rect if it can. else
                    'video rect will be adjusted to match screen rect
                    '(1: center, centerize video rect position according size of dest, it will affect VIDEO's rect
                    'set by okSetTargetRect(hBoard,VIDEO,lprcVideo);
                    ' 2: left-top fixed, take left-top of current video's rect and same size rect as dest)


'-----sub-function defines for wParam of SetDeviceParam
        'wParam cab be one of the follow
Public Const DEVICE_SETDEVMEMORY = 0        'set or get all setable parameters to and from device with memory,
                                            'lParam=-1: get device-memory's params as device current , lParam=0: store device's current param to device-memory,
                                            '=1: restore all params to hardware default
                                            '(for camera, CCU,) this func will be called in func okOpenBoard to get and okCloseBoard to set
                                            
Public Const DEVICE_SETIPADDRESS = 1        'set or get new ip address of net device. lParam is structure NETCFGPARAM pointer
Public Const DEVICE_GETMACADDRESS = 2       'only get mac address of net device. lParam is structure NETCFGPARAM pointer
                                            '(exHiWord(lEvent) is index)

Public Const DEVICE_GETACCEPTTHREAD = 3     'get handle of accept thread for capturing image from net device
Public Const DEVICE_GETPARAMCHANGED = 4     'get changed info which group parameters were set and reset the flag after call

'-----sub-function defines for lParam of PutSignalParam
Public Const PUTSIGNAL_TRIGGER = 1          'LOWORD output 1 trigger signal; HIWORD output a soft-emulation trigger
Public Const PUTSIGNAL_VERTSYNC = 2         'enbale video vertical sync. output
                                            '(for GPIO,...)
Public Const PUTSIGNAL_SYNCSTART = 3        'set start number after begin of reset pulse signal(Vertical). in unit of line pulse number
                                            '(special for LineScan)
Public Const PUTSIGNAL_SYNCCOUNT = 4        'set count number after start signal to enbale capture. in line pulse
                                            '(special for LineScan)

Public Const PUTSIGNAL_DELAYSYNC = 5        'set delay times to output sync pulse from the Basetime. in unit of us
                                            '(for camera, CCU, ...)
Public Const PUTSIGNAL_SYNCWIDTH = 6        'set sync pulse's width (in unit of us ) wihich set by PUTSIGNAL_DELAYSYNC.
                                            '(for camera, CCU, ...)     // note: it is positive pusle when b31 is 1
Public Const PUTSIGNAL_STARTCONSYNC = 11    'start sync signals as above. LOWORD is repeat period (in unit of ms) count from the Basetime,
                                            '(for CCU, )   //HIWORD (usually is 0) is a extra delay time(in ms) to the Basetime from specified ex-Trigger


Public Const PUTSIGNAL_SETVOLTRANGE = 12    'set output voltage range (like ibs for CCU), in unit of 0.1 Voltage, LOWORD=min value, HIWORD max
                                            '(for CCU,)
Public Const PUTSIGNAL_FEEDBACKFACT = 13    'set feedback factor, value range 1~16, more big more fast and sensitivity
                                            '(for CCU,)

Public Const PUTSIGNAL_SETFLASHMODE = 8     'set flash lamp, LOWORD = 0: default(auto), =1: by extra trigger, =2: single by DSP, =3; continue )
                                            '(for IC1200, )    //HIWORD: interval of flash, (1~65535) in us

Public Const PUTSIGNAL_EXTRIGDELAY = 7      'set delay time (in 10us) to generate a negtive trigger(about 20VS width) after received a ex-trigger
                                            '(for gpio )
Public Const PUTSIGNAL_SETGPIODIR = 9       'set GPIO input or output, 0: input, 1:output (b0~31 for 32 io ports)
                                            '(for gpio )
Public Const PUTSIGNAL_SETGPIOLEV = 10      'set GPIO low or hight level, 0: low level, 1: high
                                            '(for gpio )

Public Const PUTSIGNAL_SETLENS = 14         'set param of lens, LOBYTE(BYTE0) for aperture,

Public Const PUTSIGNAL_SETOPTFILTER = 15    'set param of optical filter, LOBYTE(BYTE0) for light filter,
'max=15




'-----sub-function defines for lParam of okSetConvertParam
Public Const CONVERT_RESETALL = 0           'reset all to sys default
Public Const CONVERT_FIELDEXTEND = 1        'field extend
Public Const CONVERT_PALETTE = 2            'set convert palette (just for 8 to 24 or 32)
                                            'lParam=0: restore system default, >0: set new palette (BYTE) pointer and length=256
Public Const CONVERT_HORZEXTEND = 3         'horzental extend (integer times)
'Public Const CONVERT_HORZSTRETCH = 4        'horzental stretch (arbitrary number times)
Public Const CONVERT_MIRROR = 5             'x and y mirror
Public Const CONVERT_UPRIGHT = 6            'up to righ(=1)(rotate right 90 D) or left (=2) (rotate left 90 D
Public Const CONVERT_NOSYNCSCREEN = 7       '1 no wait for sync of vertical (just when to WND for CaptureByBuffer)
                                            'b13
Public Const CONVERT_WINDOWLEVEL = 10       'set gray level window's location( middle pos) and its width, mainly for hight gray(>=8bits) to 8bits
                                            'Also for its gray of some channel is 8 bits, either src or dst
                                            ' LOWORD=middle, HIWORD=width. HIWORD=0 (default) mean no convert (it (HIWORD) should be 0 usually)
                                            'this set valid only CONVERT_LEVELMAPLUT as belowed was set to 0
Public Const CONVERT_LEVELMAPLUT = 11       'set (copy) gray level map LUT. lParam=0 (default): off, >0: set a pointer of LUT in WORD,
                                            'which must be WORD pointer anyway. LPWORD[0] is bits of gray level
                                            '(i.e. it is 8 for GRAY8, GRAY888, RGB888..,it is 16 for GRAY16), and they are true
                                            'elements of LUT from LPWORD[1].
                                            'whose max value in this LUT should be <= max value of dest to convert
                                            'it must be unset by lParam=0 after finishing convert

'-----defines lParam for wParam=CONVERT_FIELDEXTEND in okSetConvertParam
'--field extend mode
Public Const FIELD_JUSTCOPY = 0         'just copy row by row
Public Const FIELD_COPYEXTEND = 1       'copy one row and expend one row (x2)
Public Const FIELD_INTERLEAVE = 2       'just copy odd(1.) rows (/2)
Public Const FIELD_INTEREXTEND = 3      'copy one odd row and expend one row
Public Const FIELD_COPYINTERPOL = 4     'copy one odd row and interpolate one row
Public Const FIELD_INTERINTERPOL = 5    'copy odd row and interpolate even row

Public Const FIELD_INTEREVEN = 6        'just copy even(2.) rows (/2)
Public Const FIELD_INTEREXTEVEN = 7     'copy one even row and expend one row
Public Const FIELD_JUSTCOPYODD = 8      'just copy odd rows to odd rows
Public Const FIELD_JUSTCOPYEVEN = 9     'just copy even rows to even rows
Public Const FIELD_ODDEVENCROSS = 10    'copy odd and even crossly

Public Const FIELD_COPYROWTOODD = 11    'copy row by row and to odd place
Public Const FIELD_COPYROWTOEVEN = 12   'copy row by row and to even place

                                    'just for the case without bit converting

'-----sub-function defines for lParam of GetSignalParam
Public Const SIGNAL_VIDEOEXIST = 1           '0 video  absent, 1 exist
Public Const SIGNAL_VIDEOTYPE = 2            '0 field, 1 interlaced
Public Const SIGNAL_SCANLINES = 3            'scan lines per frame
Public Const SIGNAL_LINEFREQ = 4             'line frequency
Public Const SIGNAL_FIELDFREQ = 5            'field frequency
Public Const SIGNAL_FRAMEFREQ = 6            'frame frequency
Public Const SIGNAL_EXTTRIGGER = 7           'extern trigger status, 1 trigger
Public Const SIGNAL_FIELDID = 8              'Field ID 0 odd, 1 even
Public Const SIGNAL_VIDEOCOLOR = 9           'color(1) or B/W(0)
Public Const SIGNAL_TRANSFERING = 10         '1 transfering video data
Public Const SIGNAL_CAPFINISHED = 11         'capture finished
Public Const SIGNAL_HORZSYNCTIME = 12        'time of horz sync header in ns
Public Const SIGNAL_VERTSYNCTIME = 13        'time of vert sync header in ns
Public Const SIGNAL_SYNCPOLARITY = 14        'b0: horz sync pol, b1:vert sync. 0:negtive, 1:positive
Public Const SIGNAL_HORZVALPOS = 15          'horz edge and size of validate area, LOWORD is width, HIWORD is edge
Public Const SIGNAL_VERTVALPOS = 16          'vert edge and size of validate area, LOWORD is height, HIWORD is edge
Public Const SIGNAL_VIDEOCHANGED = 17        'video signal changed since last call to any items of this func, 1: changed
Public Const SIGNAL_NETCONNECT = 18          'status of net(or USB...) connected with capture device, 0: not connected
Public Const SIGNAL_FIELDFREQEX = 19         'field frequency (number of field per 1000 Seconds)
Public Const SIGNAL_FRAMEFREQEX = 20         'frame frequency (number of frame per 1000 Seconds)
Public Const SIGNAL_CHECKNETRATE = 21        'return transfer-rate of net while seconds. LOWORD is data transfer rate, in M Bytes/S.
                                             'HIWORD is rate of Frame-Lost, in number/10000 Frames
                                        

'-----sub-function defines for lEvent of WaitSignalEvent
Public Const EVENT_FIELDHEADER = 1          'field header
Public Const EVENT_FRAMEHEADER = 2          'frame header
Public Const EVENT_ODDFIELD = 3             'odd field come
Public Const EVENT_EVENFIELD = 4            'even field come
Public Const EVENT_EXTTRIGGER = 5           'extern trigger come,
                                            '(HIWORD(lEvent) is pole)




'-----defines for several target we can support
'typedef LPARAM  TARGET;

Public Const BUFFER = 1           'Buffer(physical) allocated from host memory
Public Const VIDEO = 0            'Video source input to the board
Public Const VSCREEN = -1          'Screen supported by VGA
Public Const FRAME = -2           'Frame buffer on the board
Public Const MONITOR = -3         'Monitor supported by (D/A) TV standard
Public Const GRAPH = -4           'Graph frame on the board


Public Const SEQFILE = &H5153             'SQ
Public Const BMPFILE = &H4D42             'BM
Public Const JPGFILE = &H504A             'JP
Public Const RAWFILE = &H5752             'RW
Public Const JHIFILE = &H484A             'JH

Public Const BLKHEADER = &H4B42           'BK
Public Const BMPHEADER = &H4D42           'BM
Public Const BUFHEADER = &H4642           'BF

Public Const IPADDRESS = &H4A49           'IP(J)
Public Const MACADDRESS = &H434D          'MC


'-----sub-function defines for wParam of okBeginEncode and okBeginDecode
Public Const CODE_JPEG = 1                    'use JPEGPARAM when to set, and use IMAGESIZE when to get
Public Const CODE_MPEG2 = 2                   'use MPEG2HEADER for both
Public Const CODE_MJPG = 3                    'use MJPGHEADER for both
Public Const CODE_MPEG4 = 4                   'use MPEG4HEADER for both
Public Const CODE_JPG2K = 5                   'use JPG2KHEADER for both


'-----sub-function defines for iEvent of SetEventCallback
Public Const EVENT_TOCLOSEDEVICE = 1                  'callack before close board(device)
Public Const EVENT_NETCONNECTCHANGE = 2               'callack after net connect status changed

'-----------struct defines---------------

Public Const LF_FACESIZE = 32

Type LOGFONT
        lfHeight As Long
        lfWidth As Long
        lfEscapement As Long
        lfOrientation As Long
        lfWeight As Long
        lfItalic As Byte
        lfUnderline As Byte
        lfStrikeOut As Byte
        lfCharSet As Byte
        lfOutPrecision As Byte
        lfClipPrecision As Byte
        lfQuality As Byte
        lfPitchAndFamily As Byte
        lfFaceName(LF_FACESIZE - 1) As Byte
End Type

Type RECT
        Left As Long
        Top As Long
        Right As Long
        Bottom As Long
End Type


'--app user used struct
Type tpDevType  'added after 28/02/2005, to replace struct _boardtype
    iBoardTypeCode As Long      'ok image device type code (e.g. 2030(capture card), 201100(camera))
    iBoardIdentCode As Long     'ok image device identity code (e.g. 2130), or ip value
    iBoardRankCode As Long      'ok image device model code 0,1,..
    szBoardName(23) As Byte     'ok image device name (eg."OK_M20H", "OK_AM1100"...)
    szSubDrvName(87) As Byte    'ok sub-driver name(eg. "okc30.dll")
    dwSpecCaps As Long          'special capabilities flag. b0: audio, b1:stream encoder
End Type    '128 bytes

Type tpBoardType
    iBoardTypeCode As Integer  'ok board type code (e.g. 2030)
    szBoardName As String * 18 'board name (eg."OK_M20H")
    iBoardIdentCode As Integer 'ok board identity code (e.g. 2130)
    iBoardRankCode As Integer
End Type

'image file block size
Type tpBlockSize
    iWidth As Integer      'width
    iHeight As Integer     'height
    iBitCount As Integer   'pixel bytes iBitCount
    iFormType As Integer   'rgb format type, need to fill when RGB565 or RGB 555
    lBlockStep As Long     'block stride (step to next image header)
                           'need to fill when treat multi block else set 0
End Type

'image block info
Type tpBlockInfo
    iType As Integer        '=BK or SQ, BM
    'struct _blocksize;
    iWidth As Integer       'width
    iHeight As Integer      'height
    iBitCount As Integer    'pixel bytes iBitCount
    iFormType As Integer    'rgb format type, need to fill when RGB565 or RGB 555
    lBlockStep As Integer   'block stride (step to next image header)
    iHiStep  As Integer     'exHiWord of block stride
    lTotal As Integer       'frame num
    iHiTotal As Integer     'exHiWord of total
    iInterval As Integer    'frame interval
    
    lpBits As Long ' image data pointer / file path name
    lpExtra As Long ' extra data (like as palette, mask) pointer
End Type

'sequence file info
Type tpSeqInfo 'file info for seq
    iType As Integer   '=SQ or BM
    'struct _blocksize;
    iWidth As Integer       'width
    iHeight As Integer      'height
    iBitCount As Integer    'pixel bytes iBitCount
    iFormType As Integer    'rgb format type, need to fill when RGB565 or RGB 555
    lBlockStep As Integer   'block stride (step to next image header)
    iHiStep As Integer      'exHiWord of block stride

    lTotal As Integer       'frame num
    iHiTotal As Integer     'exHiWord of total
    iInterval As Integer    'frame interval
End Type


'set raw file parameters
Type tpRawfileparam
    wRawFlag As Integer     'raw file flag,  RAWFILE:0x5752
    wPixBits As Integer     'bits per pixel
    dwWidth As Long         'width
    dwHeight As Long        'height
    dwOffset As Long        'file header
    bByteOrder As Byte      '=0: little endian͵ַЧֽڣLSBλȣλں \
                            '=1: Big endian (MSB)
    Reserved2 As Byte       'res
    reserved3 As Integer    'res
End Type

'for replay
Type tpDibInfo              'file info for seq
    lpbi As Long            'bitmap info
    lpdib As Long           'dib data
    hwndPlayBox As Long     '1 replaying, 0 quit
    iCurrFrame As Integer   'current frame in buffer
    iReserved As Integer
End Type

'---set text mode----
Type tpTextMode
    dwForeColor As Long     ' forecolor, see macro RGB in win
    dwBackColor As Long     ' backcolor, see macro RGB in win
    dwSetMode As Long       ' 0:FULLCOPY, 1: FULLXOR, ...  0x100,0x200:
    wFrameNo As Integer     ' place which frame of target
    wGroupNo As Integer     '
End Type


Public Const FULLCOPY = 0                 'copy full text region into target
Public Const FULLXOR = 1                  'xor full text region and target
Public Const COPYFONT = 2                 'just copy fonts strokes to target
Public Const XORFONT = 3                  'just xor fonts strokes and target

Public Const WM_USER = &H400

Public Const WM_BEGINSEQPROC = WM_USER + 101
        'begin seq proc, wParam=hBaord
Public Const WM_SEQPROGRESS = WM_USER + 102
        'seq in progress, wParam=hBaord, lParam=No. to
Public Const WM_ENDSEQPROC = WM_USER + 103
        'end seq proc, wParam=hBaord
Public Const WM_ASKWAITVERTICAL = WM_USER + 104
        'ask to wait next vertical blank

'---image size------
Type tpImageSize
    dwWidth As Long
    dwHeight As Long
    dwBitCount As Long
    dwTotal As Long
End Type

'--jpeg set params
Type tpJpegParam
    dwSize As Long      ' the size of this strcut
    lpstrName As Long   'must be NULL if not use
    dwQuality As Long
    dwReserved1 As Long
End Type

'----------
Type tp_imagesize_info
    lHeadSize As Long       'struct header size
    lHorzSize As Long       'width, (default=768 when it as input)
    lVertSize As Long       'height, (default=768 when it as input)
    lBitCount As Long       'bit count (default=24 when it as input)
    lTotalFrame As Long     'total frames
    lQuality As Long        'quality factor (for jpeg, default =75)
    bHardEncode As Integer  'flag of encode by harware
    wRes As Integer
    res0(4) As Long         'args reserved
End Type     '12X4

'---used to set and get image info ------
Type tp_jpg2k_header_info
    'struct _imagesize_info;
    lHeadSize As Long       'struct header size
    lHorzSize As Long       'width, (default=768 when it as input)
    lVertSize As Long       'height, (default=768 when it as input)
    lBitCount As Long       'bit count (default=24 when it as input)
    lTotalFrame As Long     'total frames
    lQuality As Long        'quality factor (for jpeg, default =75)
    bHardEncode As Integer  'flag of encode by harware
    wRes As Integer
    res0(4) As Long         'args reserved
    '---end commnon--

    lpExtraInfo As Long     'reserved, to store extra infos
    res1(16) As Long        'args reserved
End Type



'---used to set and get image info ------
Type tp_mpg2_header_info
    'Type tp_imagesize_info;
    lHeadSize As Long       'struct header size
    lHorzSize As Long       'width, (default=768 when it as input)
    lVertSize As Long       'height, (default=768 when it as input)
    lBitCount As Long       'bit count (default=24 when it as input)
    lTotalFrame As Long     'total frames
    lQuality As Long        'quality factor (for jpeg, default =75)
    bHardEncode As Integer  'flag of encode by harware
    wRes As Integer
    res0(4) As Long         'args reserved
    '---end commnon--
    
    dbFrameRate As Double   'frame rate (default=25, and it is expected rate when it as input)
    dbBitRate As Double     'bits rate

    Reserved1 As Long       'reserved
    res1(12) As Long        'args reserved
End Type


'---used to set and get image info ------
Type tp_mpg4_header_info
    'Type tp_imagesize_info;
    lHeadSize As Long       'struct header size
    lHorzSize As Long       'width, (default=768 when it as input)
    lVertSize As Long       'height, (default=768 when it as input)
    lBitCount As Long       'bit count (default=24 when it as input)
    lTotalFrame As Long     'total frames
    lQuality As Long        'quality factor (for jpeg, default =75) (real 31 level)
    bHardEncode As Integer  'flag of encode by harware
    wRes As Integer
    res0(4) As Long         'args reserved
    '---end commnon--
    
    dbFrameRate As Double   'frame rate (default=25, and it is expected rate when it as input)
    dbBitRate As Double     'bits rate, (default=4000000, and it is recommended)
    lEncodeMode As Long     'Encode mode, (value range 0~1, 0: double channels, 1:fix code rate as dbBitRate preset.
                            'default=0, when it as input)
    lInterval As Long       'Interval between key frame, (range: 1--300, default =100)
    lBFrameNum As Long      'B frame mode, (value range:0~2,  default=0. It is compatible as divx5.0
                            '=2, little coded data but more encoding times
    lQualityIdx As Long     'mpeg4 quality control level index, (value range: 0~6, default=6, mean high level)
                            'It will be better quality if value greater, but it will need longer times

    lpExtraInfo As Long     'reserved, to store extra infos
    res1(8) As Long         'args reserved
End Type




Public Const MJPG_SKIP = &H50494B53           'SKIP
Public Const MJPG_GINF = &H464E4947           'GINF

'--get infos of current decoded frame ---------
Type tp_extra_frame_info    'info of current frm
    '--Input
    dwFlgSkip As Long       'if it=="SKIP" mean skip decoded data, just get params

    '--Output of current frm decoded
    dwFrmType As Long       'type of frm, I,P,B
    dwFrmNumber As Long     'number of frm in origin video stream
    dwFrmRatio As Long      'current frm ratio
    dwTimeStamp As Long     'time stamp (in mili S)
    dwDateStamp As Long     'date stamp
    reserved(7) As Long     'res
End Type


'---used to set and get image info ------
Type tp_mjpg_header_info
    'Type tp_imagesize_info;
    lHeadSize As Long       'struct header size
    lHorzSize As Long       'width, (default=768 when it as input)
    lVertSize As Long       'height, (default=768 when it as input)
    lBitCount As Long       'bit count (default=24 when it as input)
    lTotalFrame As Long     'total frames
    lQuality As Long        'quality factor (for jpeg, default =75)
    bHardEncode As Integer  'flag of encode by harware
    wRes As Integer
    res0(4) As Long         'args reserved
    '---end commnon--
    
    dbFrameRate As Double   'frame rate (default=25, and it is expected rate when it as input)

    dwGetFrmInfo  As Long   '=="GINF" mean to get current frm's infos, and lpExtraInfo points memory to store them
    lpExtraInfo As Long     'points to memory to store extra infos returned by okDecodeImage,
                            'else it must be NULL
    res1(13) As Long        'args reserved
End Type


'--get frame type decoded---------
Type tp_mpeg_frame_info

    lHeadSize As Long       'struct size
    lFrameType As Long      'current frame type
    lSkip As Long           'input
    Reserved1 As Long       'reserved
    Reserved2 As Long       'reserved
    reserved3 As Long       'reserved
    reserved4 As Long       'reserved
End Type

'-----------------------------------------------------


'---used to set and get net-device's config param  ------
Type tp_net_cfg_param
    dwType As Integer       'not used, just id (IP,MC address.  =IPADDRESS or MACADDRESS)
    bRWFlag As Byte         ' =0:read, 1:write
    bReset As Byte          ' =1 reset immediately after write mac addr, 0: not
    szAddress(119)  As Byte 'in format of string.  ip addr, like "168.196.1.1",  //in 10 decimal
                            'mac addr, like 0x 60 50 40 30 20 10 //in 16 (hexadecimal)
                            'both address are in local machine order,  high byte first
    dwLowAddress As Long    ' in format of 16 decimal, low DWORD responds 0x40302010, string format is "64.48.32.16"
    dwHiAddress As Long     ' high DWORD, responds 0x 60 50
    lRes As Long            'reserved
End Type
'note: this structure must be set to zero.
 ' may choose any one format as input address, the format of string has priority


'------ okapi32 functions list -----------


'--1. basic routines--------------

'prolog and epilog
Declare Function okOpenBoard Lib "okapi32.dll" (ByRef iIndex As Long) As Long   'okLockBoard
        'open a Ok series board in specified index(0 based), return 0 if not found any
        'if success, return a handle to control specified board
        'if set index=-1, mean takes default index no. (default is 0 )
        'if user not specified by 'Ok Device Manager' in Control Pannel)
        'this index can be also a specified board type code, or ip address string
        'this function will change iIndex to the true used index,
        'if index input is -1 or type code

Declare Function okOpenBoardEx Lib "okapi32.dll" (ByRef iIndex As Long, ByVal hParBoard As Long, ByVal lParam As Long) As Long    ' 11/04/13
        'this is expended function of okOpenBoard
        'hParBoard is parent handle of new board to open, which usually be NULL
        'if use this func open a handle with hParBoard, the handle should be closed before hParBoard be closed
        'lParam now is not used, which should be NULL
        'others are same as okOpenBoard above,

Declare Function okCloseBoard Lib "okapi32.dll" (ByVal hBoard As Long) As Boolean  'okCloseBoard
        'Save current parameters and then unlock and close Ok board specified handle and

Declare Function okCloseBoardEx Lib "okapi32.dll" (ByVal hBoard As Long, ByVal dwSave As Long) As Boolean      'okCloseBoardEx
        'Unlock and close Ok board specified handle
        'dwSave=1: same as okCloseBoard, first save all current parameter to attached device
        'dwSave=0; not to save, just close board
        
Declare Function okGetLastError Lib "okapi32.dll" () As Long
        'Get last error msg

Declare Function okGetBufferSize Lib "okapi32.dll" (ByVal hBoard As Long, ByRef lpLinear As Long, ByRef dwSize As Long) As Long
        'get base address and size of pre-allocated buffer,
        'if success return the max. frame num in which can be store according to current set
        'else return false;
Declare Sub okGetBufferAddr Lib "okapi32.dll" (ByVal hApi As Long, ByVal iNoFrame As Long)
        'get base address of specified frame No. in BUFFER
        'if success return the linear base address
        'else return false;

Declare Function okGetTargetInfo Lib "okapi32.dll" (ByVal hApi As Long, ByVal tgt As Long, ByVal iNoFrame As Integer, ByRef wid As Integer, ByRef ht As Integer, ByRef stride As Long) As Long
        'get target info include base address, width, height and stride specified frame No.
        'if success return the linear base address and other infos, else return false;

Declare Function okGetTypeCode Lib "okapi32.dll" (ByVal hBoard As Long, ByVal lpBoardName As String) As Long
        'return type code and name of specified handle, the memory lpBoardName points must be big enough or be NULL
        'lpBoardName==-3: return code of majmin, =-4: return index number in total;  =-5 return IPCode, =-6 return HI IP
        '=-7: return HardVer; =-8: return Devce Type(0:PCI,PCI_E...,1:USB,..), =-10: return if LineScan Device
        
Declare Function okGetNetDevNumber Lib "okapi32.dll" (ByVal iTypeCode As Long, ByVal lpNameString As String) As Long
        'check and get number of ok net device by typcode or name
        'iTypeCode is type code, lpNameString is name
        'return 0, mean not net device, else return sequence number (based 1)
        '


'set rect and capture
Declare Function okSetTargetRect Lib "okapi32.dll" (ByVal hBoard As Long, ByVal target As Long, ByRef lpTgtRect As RECT) As Long
        'set target (VIDEO, SCREEN, BUFFER, FRAME)capture to or from
        'if Rect.right or .bottom) are -1 , they will be filled current value
        'special note for target=BUFFER:
        'if never set CAPTURE_BUFBLOCKSIZE, the block size(W,H) of buffer will be changed
        'according to size of right x bottom of lpRect, else the size will not changed
        'specail note 2 for hwnd:
        ' left=right mean use rect of SCREEN, left=1 & right=0 mean match real rect of hwwnd, else take its rect set
        'if success return max frames this target can support, else return <=0

Declare Function okSetToWndRect Lib "okapi32.dll" (ByVal hBoard As Long, ByVal hWnd As Long) As Boolean
        'set client rect of hwnd as screen rect


Declare Function okCaptureSingle Lib "okapi32.dll" (ByVal hBoard As Long, ByVal dest As Long, ByVal lStart As Long) As Boolean
        'capture video source to target which can be BUFFER, SCREEN, FRAME, MONITOR
        'start(o based).if success return 1, if failed return 0, if not support target -1
        'when this function sent command to grabber, then return immediately not wait to finish.
        'this function same as okCaptureTo(hBoard, Dest, wParam, 1);

Declare Function okCaptureActive Lib "okapi32.dll" (ByVal hBoard As Long, ByVal dest As Long, ByVal lStart As Long) As Boolean
        'capture continuous active video to same position in target which can be BUFFER, SCREEN, FRAME, MONITOR
        'start(o based).if success return 1, if failed return 0, if not support target -1
        'when this function sent continuous command to grabber, then return immediately
        'but note that some card like RGB30. when target is SCREEN, this function is a thread.
        'this function same as okCaptureTo(hBoard, Dest, wParam, 0);

Declare Function okCaptureThread Lib "okapi32.dll" (ByVal hBoard As Long, ByVal dest As Long, ByVal lStart As Long, ByVal lParam As Long) As Long
        'capture sequencely video to target which can be BUFFER, SCREEN, FRAME, MONITOR
        'start(o based). lParam>0: number of frame to capture to,
        'if lParam > total frames in BUFER, it will loop in rewind mode(i%total)
        'if lParam=-N mean it loop in buffer of N frame infinitely until call okStopCapture,
        'when -1 mean loop in all buffer.
        'return max num frame can be stored in the target if success,
        'return 0 if failed(eg. format not matched). -1 not support target
        'this call will create a thread to manage to capture sequencely then
        'return immediately not wait to finish. This thread will callback if need
        'this function same as okCaptureTo(hBoard, Dest, wParam, n);
        'but it is not same, when n=1 this function is also a thread and still support callback
        
Declare Function okCaptureToScreen Lib "okapi32.dll" (ByVal hBoard As Long) As Boolean
        'Start to capture to screen (video real-time display on screen) and return immediately
        'this is just a special routine of okCaptureTo(hBoard,SCREEN,0,0)

Declare Function okCaptureTo Lib "okapi32.dll" (ByVal hBoard As Long, ByVal dest As Long, ByVal start As Long, ByVal lParam As Long) As Boolean
        'capture video source to target which can be BUFFER, SCREEN, FRAME, MONITOR
        'start(o based), lParam>0: number of frame to capture to, =0: cont. mode,
        'if lParam > total frames in BUFER, it will loop in rewind mode(i%total)
        'if lParam=-1 mean it loop infinitely until call okStopCapture
        'return max num frame can be stored in the target if success,
        'return 0 if failed(eg. format not matched). -1 not support target
        'this call will return immediately not wait to finish.
        'This function is not recomended to use for new user
        '
Declare Function okPlaybackFrom Lib "okapi32.dll" (ByVal hBoard As Long, ByVal src As Long, ByVal start As Long, ByVal lParam As Long) As Boolean
        'playback on monitor from target which can be BUFFER, FRAME
        'start(o based), lParam>0: number of frame to capture to, =0: cont. mode
        'if lParam > total frames in BUFER, it will loop in rewind mode (i%total)
        'if lParam=-1 mean it loop infinitely until call okStopCapture
        'return max num frame be stored in the target if success,
        'return 0 if wrong. -1 not support target
        'this call will return immediately not wait to finish.
        '

'get status and stop capture
Declare Function okGetCaptureStatus Lib "okapi32.dll" (ByVal hBoard As Long, ByVal bWait As Integer) As Long
        'query capturing status, if bWait then wait to finish capturing, else return immediately.
        'return 0 if finished, if cont. mode capturing return target capture to
        '(which include SCREEN -1, FRAME -2, MONITOR -3)
        'if capturing to/from BUFFER or file, return the frame No.(1 based) being capturing

Declare Function okGetLineReady Lib "okapi32.dll" (ByVal hBoard As Long, ByRef iCurrFrameNo As Long, ByVal dwRes As Long) As Long
        'get current line number captured already (supported only by LineScan Capture cards)
        'get current line number already captured.
        'iCurrFrameNo returned is always total frame number(based 1) already captured, 0 mean no frame finished yet.
        'return line number(based 1) already captured in current frame, 0 mean no line fnished in current frame.
        'dwRes is reserved, should be NULL.

Declare Function okStopCapture Lib "okapi32.dll" (ByVal hBoard As Long) As Boolean
        'Stop capturing to or playback from SCREEN, BUFFER or other targets
        'return target just captured to or from.
        'if capturing to/from BUFFER or file, return the total frame No.(1 based) being capturing
        'it may be not stoped immediatly for sequence capture after returned

Declare Function okStopCaptureEx Lib "okapi32.dll" (ByVal hBoard As Long, ByVal dwCmdCode As Long, ByVal lParam As Long) As Long
        'It's a extend func of okStopCapture,


Declare Function okGetSeqCapture Lib "okapi32.dll" (ByVal hApi As Long, ByVal start As Long, ByVal count As Long) As Long
        'get current frame no. of sequence capturing to buffer
        'start: set buffer no. to use, effecting only count==0
        'count: count no. to catpure, start from count=0
        
'capture by to /from
Declare Function okCaptureByBuffer Lib "okapi32.dll" (ByVal hBoard As Long, ByVal dest As Any, ByVal start As Integer, ByVal num As Long) As Boolean
        'capture sequence images to dest by way of two frame buffers (in BUFFER),
        'the frame size and format is taken as same as current config of BUFFER
        'if dest is file name which can be .seq or .bmp (will generate multi bmp files)
        'dest can be also a user memory pointer or a BLOCKINFO pointer (with user memory pointer)
        'retrun true immediately if success. num should be great than 0

        
Declare Function okCaptureByBufferEx Lib "okapi32.dll" (ByVal hBoard As Long, ByVal fileset As Long, ByVal dest As Long, ByVal start As Long, ByVal num As Long) As Boolean
        ' all are same as okCaptureByBuffer except for fileset which is quality when to jpg file

Declare Function okPlaybackByBuffer Lib "okapi32.dll" (ByVal hBoard As Long, ByVal src As Long, ByVal start As Long, ByVal num As Long) As Boolean
        'playback sequence images on monitor from src by way of two frame buffers (in BUFFER)
        'the size and format of BUFFER will be changed to same as src
        'src can be a file name which may be .seq or .bmp (first orderd bmp files)
        ''src can be also a BLOCKINFO pointer (with infos of user memory pointer,size and format)
        'if src is just user memory pointer, this function will think its block size and format
        'are same as current config of BUFFER (in this case can not support loop function).
        'retrun true immediately if success
        'if num is great than the true frame number in src, it will loop back
        'if num=-1 mean it will loop infinitely until call okStopCapture

'set and get params
Declare Function okSetVideoParam Lib "okapi32.dll" (ByVal hBoard As Long, ByVal wparam As Integer, ByVal lParam As Long) As Long
        '----set video param sub-function defines
        'set video param and return previous param;
        'if input lParam=-1, just return previous param
        'if not support return -1, if error return -2

Declare Function okSetCaptureParam Lib "okapi32.dll" (ByVal hBoard As Long, ByVal wparam As Integer, ByVal lParam As Long) As Long
        'set capture param and return previous param;
        'if input lParam=-1, just return previous param
        'if not support return -1, if error return -2

Declare Function okSetDeviceParam Lib "okapi32.dll" (ByVal hBoard As Long, ByVal wparam As Integer, ByVal lParam As Long) As Long
        'set (net) device param and return param;
        'wParam is a item to set,
        'lParam can be single param to set, or in/out pointer, or structure pointer
        'if success return 1, else return 0


'transfer and convert rect
Declare Function okReadPixel Lib "okapi32.dll" (ByVal hBoard As Long, ByVal src As Long, ByVal start As Long, ByVal x As Integer, ByVal y As Integer) As Long
        'read value of one pixel specified (x,y) in frame start of src (SCREEN, BUFFER, FRAME...)
        'return is this pixel value, it may be with bits 8,16,24,or 32 depend on the src's format

Declare Function okWritePixel Lib "okapi32.dll" (ByVal hBoard As Long, ByVal tgt As Long, ByVal start As Long, ByVal x As Integer, ByVal y As Integer, ByVal lValue As Long) As Long
        'write value into specified (x,y) in the frame start of tgt (SCREEN, BUFFER, FRAME...)
        '
        
Declare Function okSetConvertParam Lib "okapi32.dll" (ByVal hBoard As Long, ByVal wparam As Integer, ByVal lParam As Long) As Long
        'set convert param for for function okConvertRect
        'if not support return -1, if error return -2

Declare Function okReadRect Lib "okapi32.dll" (ByVal hApi As Long, ByVal src As Long, ByVal start As Long, ByRef lpBuf As Byte) As Long
        'read data into lpBuf from rect(set previous) in frame start of dst (SCREEN, BUFFER, FRAME)
        'the data in lpBuf stored in way row by row
        'if src not supported return -1, if failed return 0,
        'return -1 if not support, return 0 failed,
        'if success return data length read in byte
        'if lpBuf=NULL, just return data length to read

Declare Function okWriteRect Lib "okapi32.dll" (ByVal hApi As Long, ByVal dst As Long, ByVal start As Long, ByRef lpBuf As Byte) As Long
        'write data in lpBuf to rect(set previous) of dst (SCREEN, BUFFER, FRAME)
        'the data in lpBuf stored in way row by row
        'return -1 if not support, return 0 failed,
        'if success return data length written in byte

Declare Function okReadRectEx Lib "okapi32.dll" (ByVal hApi As Long, ByVal src As Long, ByVal start As Long, ByRef lpBuf As Byte, ByRef lParam As Long) As Long
        'read data into lpBuf from rect(set previous) in frame start of dst (SCREEN, BUFFER, FRAME)
        'the data in lpBuf stored in way row by row
        'if src not supported return -1, if failed return 0,
        'return -1 if not support, return 0 failed,
        'if success return data length read in byte
        'if lpBuf=NULL, just return data length to read
        'LOWORD(lParamis form code for bits of lpBuf (e.g.FORM_GRAY8if it is 0 mean: as same as src
        'exHiWord(LParam) is the mode of taking channels. mode=0 take all, =1 red, =2 green, =3 blue;

Declare Function okWriteRectEx Lib "okapi32.dll" (ByVal hApi As Long, ByVal dst As Long, ByVal start As Long, ByRef lpBuf As Byte, ByRef lParam As Long) As Long
        'write data in lpBuf to rect(set previous) of dst (SCREEN, BUFFER, FRAME)
        'the data in lpBuf stored in way row by row
        'return -1 if not support, return 0 failed,
        'if success return data length written in byte
        'LOWORD(lParamis form code for bits of lpBuf (e.g.FORM_GRAY8if it is 0 mean: as same as dst
        'exHiWord(LParam) is the mode of taking channels. mode=0 take all, =1 red, =2 green, =3 blue;

Declare Function okTransferRect Lib "okapi32.dll" (ByVal hBoard As Long, ByVal dest As Long, ByVal iFirst As Long, ByVal src As Long, ByVal iStart As Long, ByVal lNum As Long) As Long
        'transfer source rect to dest rect (here target can be SCREEN, BUFFER, FRAME, also BLOCKINFO point to user memory)
        'if total in dest or src less than lNum, it will rewind to begin then continue
        'this function transfer in format of src, that means it don't convert pixel bits if dst and src are not same
        'if src or dst not supported return -1, if failed return 0,
        'if success return data length of one block image in byte

Declare Function okConvertRect Lib "okapi32.dll" (ByVal hApi As Long, ByVal dst As Long, ByVal first As Long, ByVal src As Long, ByVal start As Long, ByVal no As Long) As Long
        'transfer source rect to dest rect (here target can be SCREEN, BUFFER, FRAME, also BLOCKINFO point to user memory)
        'if total in dest or src < lNum, it will rewind to begin then continue
        'this function convert to pixel foramt of dst if dst has not same bits format as src
        'if src or dst not supported return -1, if failed return 0,
        'if success return image size of one block in pixel

Declare Function okConvertRectEx Lib "okapi32.dll" (ByVal hDstBoard As Long, ByVal dst As Long, ByVal first As Long, ByVal hSrcBoard As Long, ByVal src As Long, ByVal start As Long, ByVal no As Long) As Long
        'same as the above function okConvertRect except with src handle

        
'get and put signals
Declare Function okGetSignalParam Lib "okapi32.dll" (ByVal hBoard As Long, ByVal wparam As Long) As Long
        'Get specified param of video signal source
        'if not support return -1, if error return -2, else return param

Declare Function okWaitSignalEvent Lib "okapi32.dll" (ByVal hBoard As Long, ByVal wparam As Long, ByVal lMilliSecond As Long) As Long
        'Wait specified signal come
        'lMilliSecond is time-out time in milliseconds for to wait
        'if lMilliSecond is zero, the function returns current state immediately
        'if lMilliSecond is INFINITE(-1) wait forever until event come
        'return -1 not support, 0 speicfied signal not come, 1 come


Declare Function okPutSignalParam Lib "okapi32.dll" (ByVal hBoard As Long, ByVal wparam As Integer, ByVal lParam As Long) As Long
        'set param to output specified signal to some other device
        'if not support return -1, if error return -2,
        
'treat callback functions
Declare Function okSetSeqProcWnd Lib "okapi32.dll" (ByVal hBoard As Long, ByVal hwndMain As Long) As Boolean
        'set proc hwnd for receive message about sequence capture

Declare Function okSetSeqCallback Lib "okapi32.dll" (ByVal hBoard As Long, ByVal BeginProc As Long, ByVal SeqProc As Long, ByVal EndProc As Long) As Boolean
        'set callback function for multi-frame capturing function
        '(which are okCaptureTo, okCaptureFrom,okCaptureToFile, okCaptureFromFile)
        'see follow

Declare Function okSetUserData Lib "okapi32.dll" (ByVal hBoard As Long, ByVal lUserData As Long) As Long
        'set or get user data to or from hBoard.
        'when lUserData==-1, set nothing, else set value of lUserData to hBoard
        'return lUserData preset


''BOOL    CALLBACK BeginProc(HANDLE hBoard); 'user defined callback function
        'callback this function before to capture
''BOOL    CALLBACK SeqProc(HANDLE hBoard, long No); 'user defined callback function
        ' callback this function after finish capturing one frame
        ' No is the number(0 based) frame just finished or being playbacked.
''BOOL    CALLBACK EndProc(HANDLE hBoard); 'user defined callback function
        ' callback this function after end capturing

''BOOL    CALLBACK EventProc(HANDLE hBoard, MWORD dwReserved); //user defined callback function for okSetEventCallback

Declare Function okSetEventCallback Lib "okapi32.dll" (ByVal hBoard As Long, ByVal iEvent As Long, ByVal EventProc As Long) As Boolean
        'set some event callback proc, which will be callback before or after this event

Declare Function okSetCloseCallback Lib "okapi32.dll" (ByVal hBoard As Long, ByVal CloseProc As Long) As Boolean
        'set callback proc of okCloseBoard, which will be callback before it close board
        'same as EVENT_TOCLOSEDEVICE

'BOOL    CALLBACK CloseProc(HANDLE hBoard, DWORD dwReserved); //user defined callback function for okCloseBoard

'save and load files
Declare Function okSaveImageFile Lib "okapi32.dll" (ByVal hBoard As Long, ByVal szFileName As String, ByVal first As Long, ByVal target As Long, ByVal start As Long, ByVal num As Long) As Long
        'here target can be BUFFER, SCREEN, FRAME or user buffer pointor
        '1.if ext name=".bmp", "raw", "jpg", thus one file with single frame, then:
        'create num new file and than save one frame in each file begin from start position of target as bmp file
        'when argument num is great than 1, a: File name will be appended 000 and auto-plus-1 if without digit in
        'szFileName; b: File name will be auto-plus-1 in parts of digits if we find digit in szFileName(like aa1000.bmp);
        '
        '2.if ext name=".seq","avi", thus one file with multi-frames (we call those file as sequences file), then
        'save num frame from (start) in target into (first) frame pos in seq(sequence) file in sequencely.
        'if the file already exist the function will not delete it, that mean old contents in the file will be kept.
        'So if you want create a new seq file with a existed file name you must delete before this call .
        'for sequences file, better we use stream way called "beg,con,end" when we save multi-frames into this one file.
        'to create file just call this func whith szFileName appended ",beg", and to finish file just with szFileName
        'appended ",end", to save each frame data one by one just call it with szFileName appended ",con".
        'in this way argument first will be ignored

Declare Function okLoadImageFile Lib "okapi32.dll" (ByVal hBoard As Long, ByVal szFileName As String, ByVal first As Long, ByVal target As Long, ByVal start As Long, ByVal num As Long) As Long
        'here target can be BUFFER, SCREEN, FRAME or user buffer pointor. here first and start both are based 0
        '1.if ext name=".bmp":
        'load one frame into start position of target from bmp file
        '
        '2.if ext name=".seq":
        'load no frame into (start) in target from (first) frame pos in seq(sequence) file in sequencely.
        'return total number for sequence format file (like .seq, .avi, ...), total data length for single format file
        'not load image data when num=0

Declare Function okGetCurrImageInfo Lib "okapi32.dll" (ByVal hBoard As Long, ByVal lpImgFrmInfo As Long, ByVal lSize As Long) As Long
        'used for okLoadImageFile
        'get extra infos of current image which is last loaded by okLoadImageFile
        'lpImgFrmInfo is structure (see EXTRAFRMINFO) stored extra info, lSize should be size of the structure
        'return 1 if lpImgFrmInfo none 0, else return 0;


'load and save config files with all parameters
Declare Function okSaveConfigFile Lib "okapi32.dll" (ByVal hBoard As Long, ByVal szFileName As String) As Boolean
        'save all current parameters(include stream' params after 11/07/11 ver 4.0 )  set to specified config file
        '(*.okf: full params; *.oks:sample params; *.oko: output params),

Declare Function okLoadConfigFile Lib "okapi32.dll" (ByVal hBoard As Long, ByVal szFileName As String) As Boolean
        'load some kind of specified config file to set current all paramters
        '

'load and save flat field model
Declare Function okSaveFlatModelFile Lib "okapi32.dll" (ByVal hApi As Long, ByVal szFile As String) As Boolean
        'save flat model from buf0,and 1 to szFile
        'ext name must be ".fla"

Declare Function okLoadFlatModelFile Lib "okapi32.dll" (ByVal hApi As Long, ByVal szFile As String) As Boolean
        'load flat model file to buf0,and 1, and then set it to inner model
        'ext name must be ".fla"

'--2. special routines supported by some cards--------------

'---overlay mask:
Declare Function okEnableMask Lib "okapi32.dll" (ByVal hBoard As Long, ByVal bMask As Long) As Long
        'bMaskΪҪ0,1,2ʲΪBoolean
        '0: disable mask; 1: positive mask, 2: negative mask
        'positive: 0 for win clients visible, 1 video visible
        'negative: 0 for video visible,  1 for win client (graph) visible
        'if bMask=-1 actually not set just get status previous set
        'return last mask status,
 
Declare Function okSetMaskRect Lib "okapi32.dll" (ByVal hBoard As Long, ByRef lpRect As RECT, ByVal lpMask As Long) As Long
        'Set mask rect(lpRect is relative to lpDstRect in SetScreenRect or
        'SetBufferRect, lpMask is mask code (in byte 0 or 1). one byte for one pixel
        'if lpMask==1, set all rect region in lpRect video visible
        'if lpMask==0, set all rect region in lpRect video unvisible
        'return base linear address of inner mask bit

'---set out LUT:
Declare Function okFillOutLUT Lib "okapi32.dll" (ByVal hBoard As Long, ByVal bLUT As Long, ByVal start As Long, ByVal num As Long) As Long
        'fill specified playback out LUT.
        'bLut stored values to fill, (r0,g0,b0, r1,g1,b1 ...)
        'start: offset pos in LUT(based 0), num: num items to fill


'set input LUT:
Declare Function okFillInputLUT Lib "okapi32.dll" (ByVal hBoard As Long, ByVal bLUT As Long, ByVal start As Long, ByVal num As Long) As Long
        'fill specified input LUT.
        'bLut stored values to fill, (r0,g0,b0, r1,g1,b1 ...)
        'start: offset pos in LUT(based 0), num: num items to fill
        
Declare Function okCaptureSequence Lib "okapi32.dll" (ByVal hBoard As Long, ByVal lStart As Long, ByVal lNoFrame As Long) As Boolean
        'capture sequence to BUFFER by way of Interrupt Service Routine
        'Note: Only M10 series, M20H,M40, M60, M30, M70 and RGB20 support this way
        'wParam=start(o based). lParam>0: number of frame to capture to,
        'if lParam > total frames in BUFER, it will loop in rewind mode(i%total)
        'when -1 mean loop in all buffer. infinitely until call okStopCapture,
        'return max num frame can be stored in the target in this way if success,
        'return 0 if failed(eg. format not matched). -1 not support target
        'this call will start a Interrupt Service Routine to manage to capture sequencely then
        'return immediately not wait to finish. This routine not support callback

Declare Function okPlaybackSequence Lib "okapi32.dll" (ByVal hBoard As Long, ByVal lStart As Long, ByVal lNoFrame As Long) As Boolean
        'playback on monitor from BUFFER
        'start(0 based), lNoFrame>0: number of frame to capture to,
        'if lParam > total frames in BUFER, it will loop in rewind mode (i%total)
        'if lParam=-1 mean it loop infinitely until call okStopCapture
        'return max num frame be stored in the target if success,
        'return 0 if wrong. -1 not support
        'this call will start a Interrupt Service Routine to manage to playback sequencely then
        'return immediately not wait to finish. This routine not support callback
        '
'
Declare Function okSetDriverParam Lib "okapi32.dll" (ByVal lWhich As Long, ByVal lParam As Long) As Long
        'lWhich defined as the follow
Public Const STATICVXD = 1
Public Const INSTNTDRV = 2
Public Const ALLOCBUFFER = 3
Public Const MEMBLOCKSIZE = 4
Public Const MEMBLOCKCOUNT = 5
Public Const UNREGISTER = 6

'-- set pre-allocate buffer size in k byte
Declare Function okSetAllocBuffer Lib "okapi32.dll" (ByVal dwSize As Long) As Long
        'set the new size to preallocate in k bytes,
        'if new size is not same as current,
        'then the functuion will restart the window system

Declare Function okSetStaticVxD Lib "okapi32.dll" (ByVal lMode As Long) As Integer
        'lMode=0: check if static vxd registered.
        '=1: create static vxd register
        '=2: delete static vxd register

Declare Function okSetNTDriver Lib "okapi32.dll" (ByVal bCmd As Integer) As Integer
        'bCmd=0: check if nt driver installed.
        '=1: install nt driver
        '=2: remove nt driver

Declare Function okUnRegister Lib "okapi32.dll" (ByVal dwCmd As Long) As Boolean
        'uninstall all registered and generated infos

Declare Function okGetProgramInfo Lib "okapi32.dll" (ByVal iItem As Integer, ByVal lpString As String, ByVal iSize As Integer) As Long
        'get program info
        
Public Const PROGRAM = 1
Public Const VERSION = 2
Public Const PREFIX = 3
Public Const COMPANY = 4
Public Const TELFAX = 5
Public Const WEBEMAIL = 6
Public Const LANGUAGE = 7

Declare Function okSetLangResource Lib "okapi32.dll" (ByVal langcode As Long) As Long      '1252 for English, 936 for Simple Chinese

'--3. multi cards, channels, memories --------------
        
'---multi cards access--------
Declare Function okGetImageDevice Lib "okapi32.dll" (ByRef lpOkDevInfo As Long, ByVal lParam As Long) As Long
        'Query all Ok series Image devices available in PCI bus, USB, GigE ... return total number
        'lParam is pointer which is input/ouput. Input b0:1, re-check, b1:1, include net devices
        'Output: return flag include net devices from config set by Ok Image Manager
        
Declare Function okGetSlotBoard Lib "okapi32.dll" (ByRef lpBoardInfo As Long) As Integer
        'Query all Ok boards available in PCI bus, return total number
Declare Function okGetBoardIndex Lib "okapi32.dll" (ByVal szBoardName As String, ByVal iNo As Integer) As Integer
        'Get index (start 0) of specified board name string (it can also be typcode string)
        ' and order in same name (start 0) from current ok image device list.
        'return -1 if no this specified ok board
Declare Function okGetBoardName Lib "okapi32.dll" (ByVal lIndex As Long, ByVal szBoardName As String) As Long
        'get the board code and name of the specified index
        'return the type code if success else return 0 if no card
        
'multi cards capture
Declare Function okMulCaptureTo Lib "okapi32.dll" (ByRef lphBaord As Long, ByVal dest As Long, ByVal start As Long, ByVal lParam As Integer) As Boolean
        'control multi boards to capture to target simultaneously, lphBaord are pointer of hBoard of multi board
        'it must be end in zero.
        'other functions are same as okCaptureByBuffer

Declare Function okMulCaptureByBuffer Lib "okapi32.dll" (ByRef lphBaord As Long, ByVal tgt As Long, ByVal start As Long, ByVal num As Long) As Boolean
        'control multi boards to capture by buffer simultaneously, lphBaord are pointer of hBoard of multi board
        'it must be end in zero.
        'other functions are same as okCaptureByBuffer

'multi channels:
Declare Function okLoadInitParam Lib "okapi32.dll" (ByVal hApi As Long, ByVal iChannNo As Long) As Boolean
        'load specified chann(based 1)  (and as current chann.)of initial params
Declare Function okSaveInitParam Lib "okapi32.dll" (ByVal hApi As Long, ByVal iChannNo As Long) As Boolean
        'save current init param to specified chann(based 1) (and as current chann.)

'get and lock buffer
Declare Function okGetAvailBuffer Lib "okapi32.dll" (ByRef lpLinear As Long, ByRef dwSize As Long) As Long
        'Get free meomery buffers pre-allocated .
        'call it when user hope to access buffer directly or lock for one board
Declare Function okLockBuffer Lib "okapi32.dll" (ByVal hBoard As Long, ByVal dwSizeByte As Long, ByRef lpBasLinear As Long) As Long
        'Lock speicfiled size meomery buffers, then other handle can not use
Declare Function okUnlockAllBuffer Lib "okapi32.dll" () As Boolean
        'Unlock all buffer

'Mem Block Buffer appended to BUFFER
Declare Function okApplyMemBlock Lib "okapi32.dll" (ByVal dwBlockSize As Long, ByVal dwBlockNo As Long) As Long
        'apply mem block used as buffer appended to BUFFER
        'return the number of blocks allocated actually

Declare Function okFreeMemBlock Lib "okapi32.dll" () As Boolean
        'release appended MemBlock by okApplyMemBlock

Declare Function okGetMemBlock Lib "okapi32.dll" (ByVal hApi As Long, ByRef dwEachSize As Long, ByRef dwBlockNo As Long) As Long
        'get the number of MemBlock and size per block applied by okApplyMemBlock
        'and return the number can be as buffer as to cureent set size of BUFFER
        
Declare Function okLockMemBlock Lib "okapi32.dll" (ByVal hBoard As Long, ByVal lBlockNo As Long) As Long
        'lock number of MemBlock to specified handle

Declare Function okUnlockMemBlock Lib "okapi32.dll" () As Boolean
        'unlcok all locked MemBlock
        
'--4. apps utilities-----------------

'apps setup dialog
Declare Function okOpenSetParamDlg Lib "okapi32.dll" (ByVal hBoard As Long, ByVal hParentWnd As Long) As Boolean
        'dialog to setup video param
Declare Function okOpenSeqCaptureDlg Lib "okapi32.dll" (ByVal hBoard As Long, ByVal hParentWnd As Long) As Boolean
        'dialog to capture sequence image

Declare Function okOpenReplayDlg Lib "okapi32.dll" (ByVal hBoard As Long, ByVal hWnd As Long, ByVal src As Any, ByVal total As Long) As Long
        'open modeless dialog to replay sequence images(in BUFFER, USERBUF or seq file) on SCREEN or MONITOR
    
'declare in userdefine because vb define
'Declare Function okOpenReplayDlgEx Lib "okapi32.dll" (ByVal hBoard As Long, ByVal hWnd As Long, ByVal src As Long, ByVal total As Long, lpbi As BITMAPINFOHEADER, ByVal lpdib As Long) As Long
        'open modeless dialog to replay sequence images(in BUFFER, USERBUF or seq file) on SCREEN or MONITOR


Declare Function okAutoAdjustBright Lib "okapi32.dll" (ByVal hBoardas As Long, ByRef lpRect As RECT, ByVal dwRes As Long) As Long
        'Auto adjust image to the best seeing by setting gain, brightness, contrast and saturation if they can be set,
        'lpRect is AOI in current BUFFER to measure, it must less than rect of BUFFER and great than 8X8
        'Take whole rect of BUFFER if lpRect==NULL
        'dwRes==0, now not used.
        'return mean gray value between 0 ~ 255, if success.

Declare Function okAutoSetCapRect Lib "okapi32.dll" (ByVal hBoard As Long, ByVal Width As Long, ByVal Height As Long) As Long
        'auto set all param to adapt source video

Declare Function okOpenSetLUTDlg Lib "okapi32.dll" (ByVal hBoard As Long, ByVal hWnd As Long, ByRef lpLUT As Byte) As Boolean
        'dialog to set LUT of input and output if supported by current card
        'lpLUT is buffer to store lut value set by this routine, when press OK button
        '
'-------
Declare Function okUnifyFields Lib "okapi32.dll" (ByVal hBoard As Long, ByVal target As Long, ByVal start As Long) As Boolean
        'unify odd and even two fields which have different intensive brightness
        '
Declare Function okDiffusionFilter Lib "okapi32.dll" (ByVal hBoard As Long, ByVal target As Long, ByVal start As Long, ByVal nLoop As Integer) As Long
        'remove noise filter by diffusion method. nLoop is loop times, recommend it be 2
        'return -1 when not support (not support virtual card)

Declare Function okGuassFilter Lib "okapi32.dll" (ByVal hBoard As Long, ByVal target As Long, ByVal start As Long) As Long
        'remove noise filter by guass method
        'return -1 when not support (not support virtual card)

Declare Function okSharpFilter Lib "okapi32.dll" (ByVal hBoard As Long, ByVal target As Long, ByVal start As Long, ByVal iClass As Integer) As Long
        'image sharper by edge enhance filter, iClass = 1~4 valid, 1: min. sharper, 4: max sharper
        'return -1 when not support (not support virtual card)

Declare Function okGetFocusMeasure Lib "okapi32.dll" (ByVal hBoard As Long, ByVal target As Long, ByVal start As Long, ByRef lpRect As RECT, ByVal iMethod As Integer, ByVal iPreDegree As Integer) As Single
        'lpRect is rect to measure for fucus
        'which method, iMethod=0: deff, =1: robert, =2: 4X Laplacian, =3: 8X laplacian, =4: brenner
        'pre-process degree, iPreDegree=0: no pre-filter, =1: 3x3 cross median, =2: 3x3 squr median, =3: 5x5 squr medain, =4: 7x7 squr median
        'return mean measure value for focusness, more big more focus

Declare Function okMultiFrmMean Lib "okapi32.dll" (ByVal hBoard As Long, ByVal target As Long, ByVal start As Long, ByVal number As Long) As Long
        'acummulate number frame from start then take mean and place to start
        'return -1 when not support

Declare Function okTakeRectMean Lib "okapi32.dll" (ByVal hBoard As Long, ByVal target As Long, ByRef lpRect As RECT, ByVal start As Long, ByVal iMode As Integer) As Long
        'calculate and return gray mean of rect specified
        'if lpRect==NULL it mean whole rect of target
        'return mean gray value

Declare Function okEvaluateHistogram Lib "okapi32.dll" (ByVal hBoard As Long, ByVal target As Long, ByRef lpRect As RECT, ByVal start As Long, ByRef lpHist As Integer) As Long
        'evaluate histogram of rect specified
        'if lpRect==NULL it mean whole rect of target
        'lpHist points memery allocated by caller and its size must be great than number of gray level for TARGET
        'for color it store data of b,g,r seperately
        'if success LOWORD is number of bis(i.e. 8,10,16...), HIWORD is bits number of channels(i.e. 1 or 3) in return value

Declare Function okGetLinExtenMaplut Lib "okapi32.dll" (ByRef lpHist As Long, ByVal iNumBits As Integer, ByVal iNumChann As Integer, ByVal iIntensity As Integer, ByRef lpwLUT As Integer) As Long
        'get map lut of linear extending according to lpHist input
        'lpHist points to histogram of one image, iNumBits and iNumChannis are bits and color channles of the image
        'iIntensity is intensity (0: no change, 10:recomended value, ) to fullfill extending transfer
        'lpwLUT is memory allocated by caller, in which the maplut are stored when return sucessful

Declare Function okGetHistEquaMaplut Lib "okapi32.dll" (ByRef lpHist As Long, ByVal iNumBits As Integer, ByVal iNumChann As Integer, ByRef lpwLUT As Integer) As Long
        'get map lut of histaogram equalizing according to lpHist input
        'lpHist points to histogram of one image, iNumBits and iNumChannis are bits and color channles of the image
        'lpwLUT is memory allocated by caller, in which the maplut are stored when return sucessful



'text and graphics
Declare Function okSetTextTo Lib "okapi32.dll" (ByVal hBoard As Long, ByVal target As Long, ByRef lpRect As RECT, ByRef lfLogFont As LOGFONT, ByRef textmode As tpTextMode, ByVal lpString As String, ByVal lLength As Long) As Boolean
        'set text into the image of specified target
        'target can be SCREEN, BUFFER, FRAME, also BLOCKINFO
        'lpRect: just use its (left,top) to points start posision
        'lfLogFont: windows font definition, see window's document
        'textMode: specify forecolor, backcolor and set mode
        'lpString, lLength: text string and it's length

    
Declare Function okDrawLineTo Lib "okapi32.dll" (ByVal hBoard As Long, ByVal target As Long, ByVal lStart As Long, ByVal ptSx As Long, ByVal ptSy As Long, ByVal ptEx As Long, ByVal ptEy As Long, ByVal iForeColor As Long) As Long
        'draw a straight line into specified target
        'target can be SCREEN, BUFFER, FRAME, also BLOCKINFO
        'ptS, ptE: specify start and end point
        'iForeColor: draw value on to target
        'return the pixel count of line

        
Declare Function okDrawEllipsTo Lib "okapi32.dll" (ByVal hBoard As Long, ByVal target As Long, ByVal lStart As Long, ByRef lpRect As RECT, ByVal iForeColor As Long) As Long
        'draw a ellips into specified target
        'target can be SCREEN, BUFFER, FRAME, also BLOCKINFO
        'lpRect: specify the rect region of expected ellips
        'iForeColor: draw value on to target
        'return the pixel count of ellips

Declare Function okFillCircleTo Lib "okapi32.dll" (ByVal hBoard As Long, ByVal target As Long, ByVal lStart As Long, ByRef lpRect As RECT, ByVal lForColor As Long, ByVal iMode As Long) As Long
        'fill inside or outside of circle(or ellipse) area specified by lpRect
        'target can be GRAPH, SCREEN, BUFFER, FRAME, also BLOCKINFO
        'lpRect specify circle area, and circle's diameter take rect's max direction
        'lForColor is the value to fill.
        'iMode: b0=0: mean to fill value to outside area of circle; =1: to fill inside
        'b1=0; fill circle area; =1: fill ellipse area

Declare Function okCreateDCBitmap Lib "okapi32.dll" (ByVal hBoard As Long, ByVal target As Long, ByRef hDCBitmap As Long) As Long
        'create a memory DC compatible with windows's GDI, draw graphic and text etc. with GDI functions
        'target can be SCREEN, BUFFER, FRAME, also BLOCKINFO
        'hDCBitmap: return a handle with which we can map the graphics on the memory DC
        'to our target.
        'return the memory DC with which you can use windows"s GDI functions

Declare Function okMapDCBitmapTo Lib "okapi32.dll" (ByVal hDCBitmap As Long, ByVal lStart As Long) As Long
        'map the graphics of memory DC created by okCreateDCBitmap into specified target
        'hDCBitmap: the handle created by okCreateDCBitmap

Declare Function okFreeDCBitmap Lib "okapi32.dll" (ByVal hDCBitmap As Long) As Boolean
        'free the allocated resource by okCreateDCBitmap
        'hDCBitmap: the handle created by okCreateDCBitmap

Declare Function okWaitVerticalSync Lib "okapi32.dll" (ByVal hBoard As Long, ByVal bHeader As Boolean) As Boolean
        'wait for verticl blank.
        'bHeader=0, mean wait for begin of vertical, =1, mean wait for end.



'encode and decode
Declare Function okBeginEncode Lib "okapi32.dll" (ByVal hApi As Long, ByVal wCodeWay As Long, ByVal lParam As Long) As Long
        'start to encode images. wCodeWay is JPEG or other compress,
        'lpImageInfo is address of  preset parameters like size to encode
        'return a handle of encoder if sucessful, else  return 0
Declare Function okEncodeImage Lib "okapi32.dll" (ByVal hCoder As Long, ByVal src As Long, ByVal start As Long, ByVal lpData As Long, ByVal maxlen As Long) As Long
        'encode one frame image . src is source like BUFFER, SCREEN, FRAME and BLOCK.
        'lpData to store coded data,  maxlen is maximum length of lpCodedData
        'return the length coded data
Declare Function okEndEncode Lib "okapi32.dll" (ByVal hCoder As Long) As Long
        'end encode and release resources of encoder

Declare Function okBeginDecode Lib "okapi32.dll" (ByVal hApi As Long, ByVal wCodeWay As Long, ByVal lpData As Long, ByVal lpImageinfo As Long) As Long
        'start to decode images. wCodeWay is JPEG or other compress,
        'lpData is current start pos of coded data,
        'lpImageInfo will return image info like size, no return when it is NULL
        'return a handle of decoder if sucessful, else  return 0
Declare Function okDecodeImage Lib "okapi32.dll" (ByVal hCoder As Long, ByVal lpData As Long, ByRef length As Long, ByVal target As Long, ByVal start As Long) As Long
        'decode coded data to image.
        'lpData is pointer with coded data
        'length is input length of coded data, it also output length of real used data
        'target is aim to decode, like BUFFER, SCREEN, FRAME,BLOCK or memory pointer
        'start is pos of specified target
        'return TRUE if one image finished, else return 0
Declare Function okEndDecode Lib "okapi32.dll" (ByVal hCoder As Long) As Long
        'end decoder and release resources of decoder

'protect
Declare Function okReadProtCode Lib "okapi32.dll" (ByVal hBoard As Long, ByVal iIndex As Integer) As Long

Declare Function okWriteProtCode Lib "okapi32.dll" (ByVal hBoard As Long, ByVal iIndex As Integer, ByVal code As Long) As Long

'--5. audio section routines--------------

'-----defines wParam in okSetAudioParam
Public Const AUDIO_RESETALL = 0             'reset all to sys default
Public Const AUDIO_SAMPLEFRQ = 1            'set sample rate (in unit of samples per second)
Public Const AUDIO_SAMPLEBITS = 2           'set bits per sample to capture, lParam=-2: just get current signal's bits
Public Const AUDIO_INVOLUME = 3             'set audio input gain control
Public Const AUDIO_CALLINTERVAL = 4         'set min. interval times of callback
Public Const AUDIO_SOURCECHAN = 5           'LOWORD select channel number in one signal source, HOWORD select signal source number
Public Const AUDIO_SOUNDCHAN = 6            'LOWORD: set sound channel to capture, HIWORD: return channels supported with this signal
                                            'b0:left(mono) channel,b1:right, b2:middle, b3:left-back, b4:right back, b5:subwoof,...
Public Const AUDIO_SIGNALINFO = 7           'just get signal infos, b0=1: signal exist,


'prolog and epilog
Declare Function okOpenAudio Lib "okapi32.dll" (ByVal hBoard As Long, ByVal lParam As Long) As Long
        'open audio device owned by the video capture board
        'hBoard is handle of image board, lParam reserved argument normally must be set to 0
        'when b0 of lParam =1 mean just check if it support audio
        'return handle of the audio device

Declare Function okCloseAudio Lib "okapi32.dll" (ByVal hAudio As Long) As Boolean
        'close audio device

'capture and stop
Declare Function okCaptureAudio Lib "okapi32.dll" (ByVal hAudio As Long, ByVal target As Long, ByVal lpfnUserProc As Long, ByVal lParam As Long) As Long
        'start to capture audio data, target can be BUFFER(audio data buffer) or file name
        'lpfnUserProc is callback function pointer, it must be NULL if not using callback
        ' lParam reserved argument must be set to 0
        'return the maximum times in miliseconds the inner audio data memory can be stored for

Declare Function WriteAudioProc Lib "okapi32.dll" (ByVal hAudio As Long, ByVal lpAudBuf As Long, ByVal length As Long) As Long
        'this callback function must written as the above protype by user
        'call this function when there are enough audio data (the length in byte)
        'call this function when capture ended with argument length=0;

Declare Function okStopCaptureAudio Lib "okapi32.dll" (ByVal hAudio As Long) As Boolean
        'stop capturing audio data
        'return total length of read out by okReadAudioData

'set and get audio
Declare Function okSetAudioParam Lib "okapi32.dll" (ByVal hAudio As Long, ByVal wparam As Integer, ByVal lParam As Long) As Long
        'set the parameters to sample audio,  wParam see above defines
        'return the new set value if success
        'if not support return -1, if error return -2
        'if input lParam=-1, just return previous param

Declare Function okReadAudioData Lib "okapi32.dll" (ByVal hAudio As Long, ByVal lpAudioBuf As Long, ByVal lSize As Long) As Long
        'read audio captured from inner data buffer
        'lpAudioBuf is your memory address to store
        'lSize is data length (in byte) you expect to read
        'return the data length (in byte) truelly read

'--6. stream section routines--------------

Public Const NONE = 0               '

'-----defines wParam in okSetStreamParam

Public Const STREAM_RESETALL = 0            'reset all to sys default
Public Const STREAM_RESOLUTION = 1          'Sample resolution, 0=D1(default),1=2/3D1,2=1/2D1,3=SIF, for c20b
Public Const STREAM_BITRATEMODE = 2         'Bit Rate mode, =0: CBR(Constant), others: VBR(Variable BR)(default=3000), for c20b
Public Const STREAM_MAXBITRATE = 3          'Max Bit Rate, it is BR for CBR, it is max BR for VBR(default=9000) (kb/s), for c20b
Public Const STREAM_CALLINTERVAL = 4        'callback after interval times

Public Const STREAM_RECTSELECT = 5          '0(default): take rect same as capture, 1:itself, independent, used in like rgb60c
Public Const STREAM_RECTSOURCE = 5          'discarded, same as above
Public Const STREAM_SOURCERECT = 6          'set independent rect of stream source (lParam=&rect), for rgb60c

Public Const STREAM_PICKFRMRATE = 7         'set rate to pick number of frame per 100 frames, 0(default): auto mode . for rgb60c/e, rgb61c_e
Public Const STREAM_QUALITY = 8             'set quality factor, for rgb60c 10~100, =100: the best. 0(default) mean 50
Public Const STREAM_MAXFILELEN = 9          'Set a size limit of file's length (in MegaByte) for any file on either ntfs or fat32 file system
                                            'when great this size set it will create another new file (in format name-1.XXX, etc.).
                                            'If no limit size was specified, It will also re-create new file automatically for AVI file or on FAT32
                                            'when file size is great than 3.5G

'prolog and epilog
Declare Function okOpenStream Lib "okapi32.dll" (ByVal hBoard As Long, ByVal lParam As Long) As Long
        'open stream device owned by the video capture board
        'when b0 of lParam is 1 just check if this board support hardware compressing
        'return handle of the stream device

Declare Function okCloseStream Lib "okapi32.dll" (ByVal hStream As Long) As Long
        'close stream device

'capture and stop
Declare Function okCaptureStream Lib "okapi32.dll" (ByVal hStream As Long, ByVal target As Any, ByVal lpfnUserProc As Long, ByVal lParam As Long) As Long
        'start to capture stream data, target can be NONE(0)/BUFFER(stream buffer), or file name
        'lpfnUserProc is callback function pointer, it must be NULL if not using callback
        'lMiliSeconds=0: forever capturing until stop by okStopCaptureStream;
        ' non 0: specified periods to capture in mili-second
        'success if return non 0

Declare Function WriteStreamProc Lib "okapi32.dll" (ByVal hStream As Long, ByRef lpStreamBuf As Byte, ByVal length As Long) As Boolean
        'this callback function must written as the above protype by user
        'call this function when there are enough stream data (the length in byte)
        'lpStreamBuf is input pointer which points memory with stream data provided by system
        'length is size of input stream data this call
        'call this function when capture ended with argument length=0;

Declare Function okStopCaptureStream Lib "okapi32.dll" (ByVal hStream As Long, ByVal dwCmdCode As Long) As Long
        'stop or pause/re-encode capturing stream data
        'dwCmdCode=0: stop, dwCmdCode=1: pause, dwCmdCode:=2: re-encode
        'return total length of read out by okReadStreamData

'set and get stream
Declare Function okSetStreamParam Lib "okapi32.dll" (ByVal hStream As Long, ByVal wparam As Integer, ByVal lParam As Long) As Long
        'set the parameters to sample stream,  wParam see above defines
        'return the new set value if success
        'if not support return -1, if error return -2
        'if input lParam=-1, just return previous param

Declare Function okReadStreamData Lib "okapi32.dll" (ByVal hStream As Long, ByVal lpStreamBuf As Any, ByVal lReadSize As Long) As Long
        'read stream captured from inner data buffer
        'lpStreamBuf is your memory address to store
        'lReadSize is data length (in byte) you expect to read
        'return the data length (in byte) truelly read

Declare Function okGetCurrStream Lib "okapi32.dll" (ByVal hStream As Long, ByVal lParam As Long) As Long
        'get infos of current stream being coded by hardware
        'return number of frame coded
 

'--7. serial device embedded in board--------------
Declare Function okSetSerial Lib "okapi32.dll" (ByVal hBoard As Long, ByVal wparam As Integer, ByVal lParam As Long) As Long
        'set serial device config parameter and return previous parameter;
        'wParam is item to set, lParam is parameter value
        'if input lParam=-1, just return previous parameter not to set
        'if not support return -1, if error return -2

Public Const SERIAL_COMMINDEX = 0               'current comm index to r/w, default value=0
Public Const SERIAL_BAUTRATE = 1                'comm baut rate,like 9600,1200...default=9600
Public Const SERIAL_DATABITS = 2                'data bits, like 8,9...default=8
Public Const SERIAL_STOPBITS = 3                'stop bits, 0=1, 1=1.5, 2=2, default=0
Public Const SERIAL_PARITY = 4                  'parity bit, 0:no, 1:odd,2:even, default=0

Declare Function okReadSerial Lib "okapi32.dll" (ByVal hBoard As Long, ByVal lpBuffer As Long, ByVal lSize As Long, ByVal lTimeOut As Long) As Long
        'read data from current serial comm device
        'lpBuffer is buffer to read, lSize is size of buffer
        'return the size read actually

Declare Function okWriteSerial Lib "okapi32.dll" (ByVal hBoard As Long, ByVal lpBuffe As Long, ByVal lSize As Long, ByVal lTimeOut As Long) As Boolean
        'write data to current serial comm device
        'lpBuffer is buffer stored data to write, lSize is data length to write
        'return true if success
        
'--8. ports io utilities--------------
        'this function only used for OK PCI GPIO20
Declare Function okGetGPIOPort Lib "okapi32.dll" (ByVal Index As Integer, ByRef wPortBase As Integer) As Integer
        'get port base and count of ok PCI GPIO20
        'index is the nomber (0 based) of gpio cards,
        'wPortBase: port base,  return port count if success else return 0

' for Non-PCI IO cards on WinNT/Win2000
' you must call this function before using follow port io functions
Declare Function okSetPortBase Lib "okapi32.dll" (ByVal wPortBase As Integer, ByVal iPortCount As Integer) As Boolean
        'preset ports to use by setting port base address and port count
        'to use some ports (default port=0x300, count=4) must preset by calling this one
        'and these ports can be used correctly only after system restarted
        
'note: before call the follow i/o functions you should have called one of
'those functions: okOpenBoard, okGetGPIOPort, okGetImageDevice
Declare Function okOutputByte Lib "okapi32.dll" (ByVal wPort As Integer, ByVal data As Byte) As Boolean
    'output a byte at specified port

Declare Function okOutputShort Lib "okapi32.dll" (ByVal wPort As Integer, ByVal data As Integer) As Boolean
    'output a word at specified port

Declare Function okOutputLong Lib "okapi32.dll" (ByVal wPort As Integer, ByVal data As Long) As Boolean
    'output a dword at specified port

'----------- input data at port
Declare Function okInputByte Lib "okapi32.dll" (ByVal wPort As Integer) As Byte
    'input a byte at specified port

Declare Function okInputShort Lib "okapi32.dll" (ByVal wPort As Integer) As Integer
    'input a word at specified port

Declare Function okInputLong Lib "okapi32.dll" (ByVal wPort As Integer) As Long
    'input a dword at specified port

Declare Function okGetAddrForVB Lib "okapi32.dll" (ByRef Value As Any) As Long
        'return array address for VB
        
'-----------get time elapse
Declare Function okGetTickCount Lib "okapi32.dll" () As Long
        'same as GetTickCount but exactly than it on Win2k

Declare Sub okSleep Lib "okapi32.dll" (ByVal dwMill As Long)
        'same as Sleep but exactly than it on Win2k

Declare Function okGetTickCountMicro Lib "okapi32.dll" (ByRef lpHiDWord As Long) As Long
        'same as GetTickCount but exactly in Micro Second
        'if lpHiDWord get high dword

Declare Sub okSleepMicro Lib "okapi32.dll" (ByVal dwMicro As Long)
        'Sleep micro seconds
'-------------------end--------------------------


